/*
 * $Id: AgedClaims.java,v 1.9 2009/10/05 21:10:30 vhahacdoansc Exp $
 */
package gov.va.med.fee.claim;

import gov.va.med.fee.DataPage;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;

import java.util.List;

import javax.ejb.Local;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.DataModel;

/**
 * The Interface AgedClaims .
 */
@Local
public interface AgedClaims {

    

    /**
     * Retrieves the result count of the claim search.
     * 
     * @return results count of the claim search.
     */
    int getNumberOfResults();


    
    /**
     * builds the list.
     * 
     * @return the outcome.
     */    
    List<ClaimListEntity> buildClaimsListByType(int startRow, int pageSize, String stations, String privacyRestrictions, String visns);
    
    /**
     * Retrieves the PageControls associated with the claim search.
     * 
     * @return the page controls associated with the claim search.
     */
    PageControls getPageControls();
    
    /**
     * Retrieves the Page associated with the claim search.
     * 
     * @return the page associated with the claim search.
     */
    Page getPage();
    
  
    
    /**
     * Sets the PageControls page associated with the claim search.
     * 
     * @param newPage
     *          the new page.
     */
    void setNewPage(int newPage);
    
    /**
     * The ValueChangeListener method associated with changing the page size.
     * 
     * @param event
     *          the ValueChangeEvent.
     */
    void changePageSize(ValueChangeEvent event);
    
    
    
    
    

    DataModel getDataModel();
    DataPage<ClaimListEntity> getDataPage(int startRow, int pageSize, String stations, String privacyRestrictions, String visns);
    void doSort(String col);
    
    String getShowPrintPopup();    
    void setShowPrintPopup(String showPrintPopup);
    
    String displayDisapproval(); 
    
    String print();

    /**
    * @return
    */
    String displayReroute();
    

    /**
     * Gets the sort column associated with the claim search.
     * 
     * @return the sort column associated with the claim search.
     */
    String getSortCol();
    
    /**
     * Sets the sort column associated with the claim search.
     * 
     * @param sortCol
     *             the sort column.
     */
    void setSortCol(String sortCol);
    
    /**
     * Gets the sort direction associated with the claim search.
     * 
     * @return the sort direction associated with the claim search.
     */
    String getSortDir();
    
    /**
     * Sets the sort direction associated with the claim search.
     * @param sortDir
     *            the sort direction.
     */
    void setSortDir(String sortDir);
    
    
    
    
    
    
    
    /**
    * Destroy.
    */
    void destroy();


}
