/*
 * $Id: ClaimListEntity.java,v 1.5 2009/08/29 22:19:48 vhahacmagdua Exp $
 */
package gov.va.med.fee.claim;

import java.util.Date;
import java.math.BigDecimal;

/**
 * The class ClaimListEntity class holds data for the lists in the screens:
 * Claims Awaiting In Process Aged Pay Error
 */
public class ClaimListEntity {

   private boolean isSelected;
   private long claimIndex;
   private String facility;
   private String claimType;
   private char projectHero;
   private String vetName;
   private String vetSsn;
   private Date claimDate;
   private BigDecimal claimAmount;
   private Date dateInProcess;
   private String providerName;
   private long totalLines;
   private long linesClosed;
   private String assignedTo;
   private String claimStatus;

   /**
    * Creates a new instance of ClaimListEntity.
    */
   public ClaimListEntity() {
      isSelected = false;
      claimIndex = 0;
      facility = "";
      claimType = "";
      // projectHero = "N";
      vetName = "";
      vetSsn = "";
      claimDate = new Date();
      claimAmount = BigDecimal.ZERO;
      dateInProcess = new Date();
      providerName = "";
      totalLines = 0;
      linesClosed = 0;
      assignedTo = "";
      claimStatus = "";
   }

   /**
    * Constructs a <code>ClaimListEntity</code> given the parameters.
    * 
    * @param isSelected
    *           for checkboxes in a datatable.
    * @param claimIndex
    *           The claimIndex
    * @param facility
    *           The facility
    * @param claimType
    *           the claim type
    * @param projectHero
    *           project hero yes/no
    * @param vetName
    *           the vet's name
    * @param vetSsn
    *           the vet's SSN
    * @param claimDate
    *           the claim date
    * @param claimAmount
    *           the claim amount
    * @param dateInProcess
    *           the data in process
    * @param providerName
    *           the provider name
    * @param totalLines
    *           the total number of line items
    * @param linesClosed
    *           the number of lines closed
    * @param assignedTo
    *           who it's assigned to
    * @param claimStatus
    *           the claim status
    */

   public ClaimListEntity(boolean isSelected, long claimIndex, String facility, String claimType, char projectHero, String vetName,
         String vetSsn, Date claimDate, BigDecimal claimAmount, Date dateInProcess, String providerName, long totalLines,
         long linesClosed, String assignedTo, String claimStatus) {
      this.isSelected = isSelected;
      this.claimIndex = claimIndex;
      this.facility = facility;
      this.claimType = claimType;
      this.projectHero = projectHero;
      this.vetName = vetName;
      this.vetSsn = vetSsn;
      this.claimDate = claimDate;
      this.claimAmount = claimAmount;
      this.dateInProcess = dateInProcess;
      this.providerName = providerName;
      this.totalLines = totalLines;
      this.linesClosed = linesClosed;
      this.assignedTo = assignedTo;
      this.claimStatus = claimStatus;
   }

   public final void setIsSelected(boolean isSelected) {
      this.isSelected = isSelected;
   }

   public final boolean getIsSelected() {
      return this.isSelected;
   }

   public final void setClaimIndex(long claimIndex) {
      this.claimIndex = claimIndex;
   }

   public final long getClaimIndex() {
      return this.claimIndex;
   }

   public final void setFacility(String facility) {
      this.facility = facility;
   }

   public final String getFacility() {
      return this.facility;
   }

   public final void setClaimType(String claimType) {
      this.claimType = claimType;
   }

   public final String getClaimType() {
      return this.claimType;
   }

   public final void setProjectHero(char projectHero) {
      this.projectHero = projectHero;
   }

   public final char getProjectHero() {
      return this.projectHero;
   }

   public final void setVetName(String vetName) {
      this.vetName = vetName;
   }

   public final String getVetName() {
      return this.vetName;
   }

   public final void setVetSsn(String vetSsn) {
      this.vetSsn = vetSsn;
   }

   public final String getVetSsn() {
      return this.vetSsn;
   }

   public final void setClaimDate(Date claimDate) {
      this.claimDate = claimDate;
   }

   public final Date getClaimDate() {
      return this.claimDate;
   }

   public final void setClaimAmount(BigDecimal claimAmount) {
      this.claimAmount = claimAmount;
   }

   public final BigDecimal getClaimAmount() {
      return this.claimAmount;
   }

   public final void setDateInProcess(Date dateInProcess) {
      this.dateInProcess = dateInProcess;
   }

   public final Date getDateInProcess() {
      return this.dateInProcess;
   }

   public final void setProviderName(String providerName) {
      this.providerName = providerName;
   }

   public final String getProviderName() {
      return this.providerName;
   }

   public final void setTotalLines(long totalLines) {
      this.totalLines = totalLines;
   }

   public final long getTotalLines() {
      return this.totalLines;
   }

   public final void setLinesClosed(long linesClosed) {
      this.linesClosed = linesClosed;
   }

   public final long getLinesClosed() {
      return this.linesClosed;
   }

   public final void setAssignedTo(String assignedTo) {
      this.assignedTo = assignedTo;
   }

   public final String getAssignedTo() {
      return this.assignedTo;
   }

   public final void setClaimStatus(String claimStatus) {
      this.claimStatus = claimStatus;
   }

   public final String getClaimStatus() {
      return this.claimStatus;
   }
}
