package gov.va.med.fee.claim;

import static org.jboss.seam.ScopeType.SESSION;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import javax.ejb.Stateful;

import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.log.Log;

import javax.ejb.Remove;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;
import javax.persistence.Query;


/**
 * ClaimPaymentBean class.
 * This class implements the ClaimPayment interface and handles the calculation and display of
 * all of the new payment fields in the GUI.
 * @author Bill Blackmon
 * @version R1.25.1
 * 
 * HAPE POR VA DO# 118-11-D-1009, TO#118-1009-0001; HARRIS
 */
@SuppressWarnings("unused")
@Stateful
@Name("claimPaymentBean")
@Scope(SESSION)



public class ClaimPaymentBean implements ClaimPayment {

	/** The log. */
    @Logger
    private Log log;


    /** The em. */
    @PersistenceContext(unitName = "FPPS_Owner", type=PersistenceContextType.EXTENDED)
    private EntityManager em;
    
    
    // values for line items
    /**
      fpl.paid_amount
      fpl.adjustment_reason_code_1,
      fpl.adjustment_amount_1,
      fpl.adjustment_reason_code_2,
      fpl.adjustment_amount_2,"
     */
    

/**
 * required fields used in display:
 * adjReasonCodeOne
   adjAmtString
   lineItemCount
   checkNumber
   paidAmountFormatted
   treasuryPaymentDateFormatted
 */

    private String checkNumber="";
    private String adjReasonCodeOne="";
    private String adjAmtString="";
    private String treasuryPaymentDateFormatted = "";
    private String paidAmountFormatted="";
    private int lineItemCount;
    private java.sql.Date treasuryPaymentDate;
    private BigDecimal treasuryPaymentAmount;
    private BigDecimal adjAmtOne;
    private BigDecimal paidAmount;
    
    
    private java.sql.Timestamp lineItemTreasuryPaymentDate;
    // new value to display String value in case above is null...
    private String lineItemTreasuryPaymentDateFormatted="";
    
    
    private String lineItemPaidAmountFormatted="";
    private String lineItemCheckNumber="";
    private String lineItemAdjAmts="";
    private String lineItemCodes="";


    SimpleDateFormat formatter = new SimpleDateFormat("MM/dd/yyyy");
    DecimalFormat df = new DecimalFormat("$#0.00");


    private long claimIndex;

    /**
     * @author Bill Blackmon
     */
    public ClaimPaymentBean(){}


    /**
     * Constructor
     * @author Bill Blackmon
     * @param em EntityManager instance
     * @param claimIndex current claim being processed
     * @since 4/30/2013
     * 
     */

    public ClaimPaymentBean(long claimIndex, EntityManager em) {

    				this.em = em;
   					this.claimIndex=claimIndex;

					setAdditionalInfoOne(claimIndex);
					setAdditionalInfoTwo(claimIndex);


    }	// end constr()

    /**
     * FIELDS IN DISPLAY FOR METHOD BELOW..
{_claimLineItem.claimPaymentBean.lineItemTreasuryPaymentDate}">
{_claimLineItem.claimPaymentBean.lineItemPaidAmount}">
#{_claimLineItem.claimPaymentBean.checkNumber}" />
#{_claimLineItem.claimPaymentBean.lineItemAdjAmtTwo}" >
#{_claimLineItem.claimPaymentBean.adjReasonCodeOne}"></h:outputText>


     */

    /**
     * This method sets information for display on the 'Additional Info' tab
     * @param claimIndexId
     * @author VHAISDBLACKW
     * @since 4/18/2013
     * @param claimIndexId
     */
    public void setAdditionalInfoTwo(long claimIndexId) {

    	Query q;
	    List<?> l;
	    Iterator<?> it;
	    StringBuffer sCheckNumber = new StringBuffer();
	    StringBuffer sAmt = new StringBuffer();
	    StringBuffer sDate = new StringBuffer();
	    String temp = "";
	    final String COMMA=", ";
	    BigDecimal paidAmount=null;

/** original **/
/**	    
    	String sql = "select " +
    				" check_number, sum(l.paid_amount), trunc(check_date) " +
					" from " +
					    " fee_claim_payments f, fee_claim_payment_lines l " +
					 " where " +
					 "   f.claim_index = " + claimIndexId + " and " +
					  "  F.FEE_CLAIM_PAYMENT_ID = L.FEE_CLAIM_PAYMENT_ID " +
					" group by " +
					    " trunc(check_date),check_number " +
					" order by " +
					 "   trunc(check_date), check_number ";
**/
	    
// NEW - 7/11

/**
 * 
Treasury Payment Date (PD):
 
03/02/2011 



Total Paid Amt per PD:
 
$1079.83 



Check/EFT/TRN:
	    
 */
 String sql = " select " + 
    " payment_tracking_number, " +    
    " sum(paid_amount), " + 
    " trunc(treasury_payment_date) " +
" from " + 
    " claim_payment " + 
" where " + 
    " claim_index = " + claimIndexId + " " +
" group by " +     
	" payment_tracking_number,trunc(treasury_payment_date) ";    



    	 try {
// System.out.println("setAdditionalInfoTwo() line level info - SQL IS: " + sql);

    		 					      q = this.em.createNativeQuery(sql);
     		 					      l = q.getResultList();
    		 					      it = l.iterator();
    		 					      int count=0;

    		 					      while (it.hasNext()) {
    		 					    	 count++;
    		 					         Object[] row = (Object[]) it.next();

    		 					         // " trunc(check_date), check_number,   " +
    		 					         temp="";
    		 					         
    		 					         
// TO DO: CHECK FOR NULL VALUES EVERYWHERE - CLAIM 86920705 IS BREAKING THE APP......    		 					         
    		 					         
    		 					         
    		 					         if(row != null) {
    		 					        	 // checkNumber
    		 					        	 // viewClaim.claimPaymentBean.checkNumber
    		 						         if(row[0] != null) {
    		 						        	 temp=(String) row[0];
    		 						        	 sCheckNumber.append(temp+COMMA);
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() CheckNumber is: " + sCheckNumber.toString());
    		 						         }	else { // end row[0]
    		 						        	 
    		 						        	 
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() - checkNumber is null: setting to empty String");
												sCheckNumber.setLength(0);
    		 						        	 
    		 						        	 
    		 						         }

     		 					        	 if(row[1] != null) {
     		 					        		 
     		 					        		 try {
			    		 					        		paidAmount = (BigDecimal) row[1];

// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() - Paid Amount is: " + paidAmount);

			    		 					        		
// TEST FOR NEGATIVE PAID AMOUNTS....
//			    		 					        		paidAmount = new BigDecimal(-100.00);	
// TEST FOR 0 PAID AMOUNTS			    		 					        		
			    		 					        		// paidAmount = new BigDecimal(0.00);
			    		 					        		
//			    		 					        		if(paidAmount.signum() == -1) {
// System.out.println("setAdditionalInfoTwo - negative paid amount: " + paidAmount);			    		 					        			
			    								        		 // this.bNegativePaidAmount=true;
//			    								        	 }
// handle positive, negative and 0 amts the same 		
			    		 					        		
					    		 					        		if( (paidAmount.floatValue() > 0.00) || (paidAmount.floatValue() < 0.00) || (paidAmount.floatValue() == 0.00) ) {
					    		 					        			temp  = df.format(paidAmount.floatValue());
//		System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() Paid Amt is: " + temp);
					    		 					        			sAmt.append(temp+COMMA);
					    		 					        			// System.out.println("SB Paid Amt is: " + sAmt.toString());
					    		 					        		} else {
//		System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() ZERO PAID AMOUNT - NOT APPENDING");
					    		 					        		}
			    		 					        		
// Negative paid amt. logic from fee final app
/**
  if(claimPaymentAmount != null) {
						           	 if(claimPaymentAmount.signum() == -1) {
						        		 this.bNegativePaidAmount=true;
						        	 }
						           	this.setClaimPaymentAmount(claimPaymentAmount.doubleValue());
						           	
System.out.println("setClaimChargePaymentAmounts() - ClaimPaymentAmt is: " + this.claimPaymentAmount);		

						           	this.bNullClaimPaymentAmount=false;
				           	 
					        	 }	else {
					        		 this.bNullClaimPaymentAmount=true;
					        		 
System.out.println("NULL CLAIM PAYMENT AMOUNT IS TRUE");					        		 
					        		 
					        	 }			    		 					        		
 */
			    		 					        		
			    		 					        		
			    		 					        		
			    		 					        		// System.out.println("Amt. is: " + sAmt.toString());
    		 					        		 }catch(Exception ex) {
System.out.println("ClaimPaymentBean.setAdditionalInfoTwo()  ERROR WITH paid amount: " + ex.getMessage());
    		 					        			 ex.printStackTrace();
    		 					        		 }
    		 					        	 }	else { 
    		 					        		 
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() - paid amount is null.....");    		 					        		 
    		 					        		 // end row[1]
    		 					        	 }

    		 					        	 // trunc(check_date)
    		 					        	 // viewClaim.claimPaymentBean.treasuryPaymentDateFormatted
    		 					        	 if(row[2] != null) {
    		 					        		 try {
			    		 					        		java.sql.Timestamp x = (java.sql.Timestamp) row[2];
			    		 					        		temp = formatter.format(x);
			    		 					        		sDate.append(temp+COMMA);
// System.out.println("formatted date is: " + sDate);
    		 					        		 } catch(Exception ex) {
    		 					        			 System.out.println("ERROR WITH paymentDate: " + ex.getMessage());
    		 					        			 ex.printStackTrace();
    		 					        		 }

    		 					        	 } else {
    		 					        		 
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() - check date is null");  

    		 					        		 
    		 					        		 
    		 					        	 }

    		 					         }	// end if

    		 					      }	// end while


										this.lineItemCount=count;
										// System.out.println("COUNT OF RECORDS IS: " + count);

   										// trim semi-colons from end and assign to output fields
// THIS BLOWS UP WHEN VALUES ARE NULL..............										
										
										
										if(count > 0) {
											try {
												
												// IF ANY OF THESE ARE SET TO EMPTY STRING, LENGTH=O, SKIP PROCESSING..
												if(sCheckNumber.length() > 0) {
													sCheckNumber=new StringBuffer(sCheckNumber.deleteCharAt(sCheckNumber.length()-2));
												}
												
												if(sAmt.length() > 0) {
													sAmt=new StringBuffer(sAmt.deleteCharAt(sAmt.length()-2));
												}
												
												if(sDate.length() > 0) {
													sDate=new StringBuffer(sDate.deleteCharAt(sDate.length()-2));
												}
												
											} catch(IndexOutOfBoundsException  iob)	{
												  System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() ERROR: " + iob.getMessage());
					    		 		    	  System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() claim index is: " + claimIndexId);
					    		 		    	  iob.printStackTrace();
					    		 		    	  log.error(iob.getMessage(), iob);
											} catch(Exception x) {
												 System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() ERROR: " + x.getMessage());
					    		 		    	 System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() claim index is: " + claimIndexId);
					    		 		    	 x.printStackTrace();
					    		 		    	 log.error(x.getMessage(), x);
											}
										}


// HANDLE NULLS										
										this.checkNumber=sCheckNumber.toString();
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() - CHECK NUMBER STRING IS: " + this.checkNumber);

// HANDLE NULLS
										this.paidAmountFormatted=sAmt.toString();
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() AMT STRING IS: " + this.paidAmountFormatted);

										
// HANDLE NULLS										
										
										this.treasuryPaymentDateFormatted=sDate.toString();
// System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() - treasuryPaymentDate is: " + this.treasuryPaymentDateFormatted);

										/**
										 *   <h:outputText value="#{viewClaim.claimPaymentBean.treasuryPaymentDateFormatted}"/>

	                    					<h:outputLabel name="label">Total Paid Amt per PD:</h:outputLabel>
	                    					<h:outputText value="#{viewClaim.claimPaymentBean.paidAmountFormatted}"/>

	                     					<h:outputLabel name="label">Check/EFT/TRN:</h:outputLabel>
	                    					<h:outputText value="#{viewClaim.claimPaymentBean.checkNumber}" />
										 */


    		 		      }catch(Exception ex) {
    		 		    	  System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() ERROR: " + ex.getMessage());
    		 		    	  System.out.println("ClaimPaymentBean.setAdditionalInfoTwo() claim index is: " + claimIndexId);
    		 		    	  ex.printStackTrace();
    		 		    	  log.error(ex.getMessage(), ex);
    		 		      }


    }	// end setAdditionalInfoOne()

    public BigDecimal getPaidAmount() {
		return paidAmount;
	}


	/**
     * Populates CARC and TotalAmtPerCarc on Additional Tab
     * @param claimIndexId
     * @author Bill Blackmon
     * @since 4/18/2013
     */

    public void setAdditionalInfoOne(long claimIndexId) {

    	Query q;
	    List<?> l;
	    Iterator<?> it;
	    StringBuffer sCode = new StringBuffer();
	    StringBuffer sAmt = new StringBuffer();
	    final String COMMA=", ";
	    String curCode = "";
	    String prevCode = "";
	    float curAmt = 0;
	    float prevAmt = 0;


	    int recCount = 0;

	    boolean bSameCode = false;

// Original
/**	    
    	String sql = "select sum(l.adjustment_amount_1), l.adjustment_reason_code_1 " +
    			" from " +
    			   " fee_claim_payments f, fee_claim_payment_lines l " +
    			" where " +
    			    " f.claim_index = " + claimIndexId + " and " +
    			    " F.FEE_CLAIM_PAYMENT_ID=L.FEE_CLAIM_PAYMENT_ID and " +
    			    " l.adjustment_reason_code_1 is not null " +
    			" group by " +
    			    " l.adjustment_reason_code_1 " +
    			" union " +
    			" select " +
    			   " sum(l.adjustment_amount_2), l.adjustment_reason_code_2 " +
    			" from " +
    			   " fee_claim_payments f, fee_claim_payment_lines l " +
    			" where " +
    			    " f.claim_index = " + claimIndexId + " and " +
    			    " F.FEE_CLAIM_PAYMENT_ID=L.FEE_CLAIM_PAYMENT_ID and " +
    			    " l.adjustment_reason_code_2 is not null " +
    			" group by " +
    			    " l.adjustment_reason_code_2 order by adjustment_reason_code_1 ";
**/
	    

/** NEW - 7/11 **/
 
  String sql = " select " + 
    " sum(adjustment_amount), CPRA.ADJUSTMENT_REASON_CD " + 
" from " +
    " claim_proc_rec_adjust cpra, claim_proc_recon c " +
" where " +
    " c.claim_proc_rec_id = cpra.claim_proc_rec_id and " +
    " claim_index =  " + claimIndexId + " group by cpra.adjustment_reason_cd ";
    	
   	
// System.out.println("setAdditionalInfoOne()  CARC and TotalAmtPerCarc - SQL IS: " + sql);

    	 try {

    		 					      q = this.em.createNativeQuery(sql);
     		 					      l = q.getResultList();
    		 					      it = l.iterator();

     		 					      while (it.hasNext())
     		 					      {

     		 					    	recCount++;

    		 					         Object[] row = (Object[]) it.next();

// TO DO: CHECK FOR NULL VALUES FOR EACH FIELD..............data is garbage.
    		 					         // if the row is not null.....
    		 					         if(row != null)
    		 					         {

    		 					        	 // if the first value in the row is not null
    		 					        	 if(row[0] != null)
    		 					        	 {
      			 					        		 // if the amount is > 0 do it.....
     		 					        		 BigDecimal adjAmt = (BigDecimal) row[0];
// System.out.println("setAdditionalInfoOne() - BILLED/ADJUSTMENT AMOUNT IS: " + adjAmt.floatValue()) ;
// System.out.println("  " + adjAmt.floatValue());

// TEST FOR 0 VALUES......
     		 					        		 // if the value of the item is not 0 - INCLUDE NEGATIVE AMOUNTS - all further processing depends on this value
     		 					        		 if(adjAmt.floatValue() != 0.00)
     		 					        		 {
     		 					        			recCount++;

       		 					        			 	curAmt = adjAmt.floatValue();
       		 					        			 	// System.out.println("Top - new amt is: " + curAmt);

       		 					        		 		if(row[1] != null) {
								    		 				curCode=(String) row[1];


								    		 				if(recCount != 1) {

// System.out.println("setAdditionalInfoOne() -New row/code - prev and current codes are now: " + curCode + ", " + prevCode);

									    		 						        	 if(!curCode.equalsIgnoreCase(prevCode) ) {
									    		 						        		 sCode.append(curCode+COMMA);
// System.out.println("setAdditionalInfoOne() -New Code found - sCode is: " + sCode.toString());
									    		 						        	 } else {	// for testing...
									    		 						        		// SET FLAG FOR PROCESSING AT END OF RECORD READ
																						bSameCode=true;
/**
System.out.println("setAdditionalInfoOne() - SAME CODE FOUND! - codes are: ..... - cur code is: " + curCode + ", prev code is: " + prevCode);
System.out.println("setAdditionalInfoOne() - SAME CODE FOUND! - amts are: .......cur amt is: " + curAmt + ", prev amt is: " + prevAmt);
System.out.println("setAdditionalInfoOne() - SAME CODE.....current amount String is: " + sAmt.toString());
**/
									    		 						        	 }
								    		 						        	 } else {	// first record - append it....
								    		 						        		 // if this is the first record append it regardless.....

								    		 						        		 // WATCH THIS FOR EXTRANEOUS ADDITION.....
								    		 						        		 sCode.append(curCode+COMMA);
// System.out.println("setAdditionalInfoOne() - FIRST RECORD - appending code....sCode is: " + sCode.toString());
								    		 						        	 }	// end recCount if

								    		 		    } else {
								    		 		    	
// System.out.println("setAdditionalInfoOne() - ClaimPaymentBean.setAdditionalInfoOne() - curCode IS NULL");								    		 		    	
								    		 		    } // end row[1] check....

				    		 					        // check for bSameCode flag
     		 					        		 		// if flag is true, sum prevAmt and curAmt and append to String
     		 					        		 		// otherwise, just append curAmt
     		 					        		 		if(bSameCode) {


																	String out = sAmt.toString();

																	int len = out.length();
																	int pos = 0;

																	for (int i = out.length(); (i = out.lastIndexOf(COMMA, i - 1)) != -1; ) {
																	     // System.out.println("Position of COMMA from the end is: " + i);
																	     pos = i;
																	 }

																	String sub = out.substring(0, pos+1);
																	// System.out.println("NEW OUTPUT STRING IS: " + sub);


																	sAmt = new StringBuffer(sub);

																	// System.out.println("NEW sAmt StringBuffer is: " + sAmt.toString());

																	// System.out.println("bSameCode check - curAmt and prevAmts are: " + curAmt + "; " + prevAmt);
																	float sum = prevAmt+curAmt;
																	// System.out.println("bSameCode check - total for curAmt and prevAmt is: " + sum);

																	this.adjAmtOne = new BigDecimal(sum);
																	// System.out.println("bSameCode check - new amt is: " + this.adjAmtOne)	;


																	String x = df.format(this.adjAmtOne);

																	// dress it
																		sAmt.append(" " + x + COMMA);



     		 					        		 		} else {	// process and format the curAmt here....
																	this.adjAmtOne = new BigDecimal(curAmt);
// System.out.println("setAdditionalInfoOne() - bSameCode check -NOT THE SAME new amt is: " + this.adjAmtOne)	;
																	String y = df.format(this.adjAmtOne);
																	 // dress it
																	sAmt.append(y+COMMA);
// System.out.println("setAdditionalInfoOne() - END OF adjAmt processing - sAmt is now: " + sAmt.toString());
     		 					        		 		}	// end bSameCode check....



							    		 					         //  reset values .....
							    		 					         prevAmt = curAmt;
							    		 					         prevCode = curCode;

																	// sanity check
/**							    		 					         
System.out.println("setAdditionalInfoOne() - RECORD COUNT is: " + recCount);
System.out.println("setAdditionalInfoOne() - NEXT RECORD - curAmt and curCode are: " + curAmt + " : " + curCode);
System.out.println("setAdditionalInfoOne() - NEXT RECORD - prevAmt and prevCode are: " + prevAmt + " : " + prevCode);
System.out.println("setAdditionalInfoOne() - NEXT RECORD - sAmt and sCode are: " + sAmt.toString() + " : " + sCode.toString());
**/

								    		 					    curAmt = 0;
							    		 					        curCode = "";

							    		 					        bSameCode = false;

		    		 					         }	else {

		    		 					        	 // debug for 0 amts.....
/**		    		 					        	 
System.out.println("setAdditionalInfoOne() - 0 amt - current setting are: ");
System.out.println("setAdditionalInfoOne() - 0 amt - record count is: " + recCount);
System.out.println("setAdditionalInfoOne() - 0 amt - curAmt and curCode are: " + curAmt + " : " + curCode);
System.out.println("setAdditionalInfoOne() - 0 amt - prevAmt and prevCode are: " + prevAmt + " : " + prevCode);
System.out.println("setAdditionalInfoOne() - 0 ant - sAmt and sCode are: " + sAmt.toString() + " : " + sCode.toString());
**/


		    		 					         }	// end adjAmt > 0 check


    		 					        	 }	else { 
// System.out.println("ClaimPaymentBean.setAdditionalInfoOne() - ADJUSTMENT AMOUNT IS NULL");    		 					        		 
    		 					        	 }	// end row entry null check
    		 					        	 
    		 					        	 
    		 					        	 

    		 					         }	 else { // end row null check
    		 					        	 
    		 					        	 
// System.out.println("ClaimPaymentBean.setAdditionalInfoOne() - intial record returned is null - EVERTHING IS SET TO DEFAULT VALUES");    		 					        	 
    		 					        	 
    		 					        	 
    		 					         }

    		 					      }	// end while

    		 					    // trim
     		 					     // ERROR: String index out of range: -2 - test for records with NO DETAILS....
     		 					      
// TO DO: 7/12 - TEST FOR NULL VALUES FOR EVERYTHING IN THIS BLOCK......     		 					      
     		 					      if(recCount > 0) {
     		 					    	  
     		 					    	try {
											
	     		 					    	  if( (sCode.length() > 2) && (sAmt.length() > 2) ) {
												sCode=new StringBuffer(sCode.deleteCharAt(sCode.length()-2));
												sAmt=new StringBuffer(sAmt.deleteCharAt(sAmt.length()-2));
	
												// assign
												this.adjReasonCodeOne=sCode.toString();
												this.adjAmtString=sAmt.toString();
	     		 					    	  }
	     		 					    	  
     		 					    	} catch(IndexOutOfBoundsException  iob)	{
											  System.out.println("ClaimPaymentBean.setAdditionalInfoOne() ERROR: " + iob.getMessage());
				    		 		    	  System.out.println("ClaimPaymentBean.setAdditionalInfoOne() claim index is: " + claimIndexId);
				    		 		    	  iob.printStackTrace();
				    		 		    	  log.error(iob.getMessage(), iob);
										} catch(Exception x) {
											 System.out.println("ClaimPaymentBean.setAdditionalInfoOne() ERROR: " + x.getMessage());
				    		 		    	 System.out.println("ClaimPaymentBean.setAdditionalInfoOne() claim index is: " + claimIndexId);
				    		 		    	 x.printStackTrace();
				    		 		    	 log.error(x.getMessage(), x);
										}	  
	     		 					    	  
	     		 					    	  
	     		 					    	  
     		 					     }

// System.out.println("setAdditionalInfoOne() END - Code String is: " + this.adjReasonCodeOne);
// System.out.println("setAdditionalInfoOne() END - Amount String is: " + this.adjAmtString);



   		 	} catch(Exception ex) {
    		  	  System.out.println("ClaimPaymentBean.setAdditionalInfoOne() ERROR: " + ex.getMessage());
 		    	  System.out.println("ClaimPaymentBean.setAdditionalInfoOne() claim index is: " + claimIndexId);
 		    	  ex.printStackTrace();
 		    	  log.error(ex.getMessage(), ex);
	 		 }


    }	// end setAdditionalInfoOne()


    


	
	@Override
	public String getPaidAmountFormatted() {

			return this.paidAmountFormatted;
	}

	public void setPaidAmount(BigDecimal paidAmount) {
		this.paidAmount = paidAmount;
	}


	public void setPaidAmountFormatted(String paidAmount) {
		this.paidAmountFormatted = paidAmount;
	}


	
	
//// GETTERS AND SETTERS 
	/**
	 * @return the lineItemCount
	 */
	@Override
	public int getLineItemCount() {
		return lineItemCount;
	}


	@Override
	public void setLineItemCount(int lineItemCount) {
		this.lineItemCount = lineItemCount;
	}

	@Override
	public String getCheckNumber() {
		return this.checkNumber;
	}

	@Override
	public void setCheckNumber(String checkNumber) {
		this.checkNumber = checkNumber;
	}



	@Override
	public String getAdjReasonCodeOne() {
		return this.adjReasonCodeOne;
	}



// generated methods
    @Destroy
    public void destroy() {
    }

    @Remove
    public void remove() {
    }





	// @Override
	public java.sql.Date getTreasuryPaymentDate() {
		return this.treasuryPaymentDate;
	}


	@Override
	public String getTreasuryPaymentDateFormatted() {
		return treasuryPaymentDateFormatted;
	}


	public void setTreasuryPaymentDateFormatted(String treasuryPaymentDateFormatted) {
		this.treasuryPaymentDateFormatted = treasuryPaymentDateFormatted;
	}


	public long getClaimIndex() {
		return claimIndex;
	}


	public void setClaimIndex(long claimIndex) {
		this.claimIndex = claimIndex;
	}


	@Override
	public void setAdjReasonCodeOne(String adjReasonCodeOne) {
		this.adjReasonCodeOne = adjReasonCodeOne;
	}


	@Override
	public String getAdjAmtString() {
		return adjAmtString;
	}


	/**
	 * @param adjAmtString the adjAmtString to set
	 */
	@Override
	public void setAdjAmtString(String adjAmtString) {
		this.adjAmtString = adjAmtString;
	}

	@Override
	public java.sql.Timestamp getLineItemTreasuryPaymentDate() {
		return lineItemTreasuryPaymentDate;
	}

	@Override
	public void setLineItemTreasuryPaymentDate(java.sql.Timestamp lineItemTreasuryPaymentDate) {
		this.lineItemTreasuryPaymentDate = lineItemTreasuryPaymentDate;
	}

	/**
	 * @return the lineItemTreasuryPaymentDateFormatted
	 */
	public String getLineItemTreasuryPaymentDateFormatted() {
		

		String retVal = "";
		// String temp = ""; 
			
		// this is the value of a java.sql.Timestamp created with the constructor arg of -1
		// it is created when the DB returns a null value 
		String nullString = "1969-12-31 17:59:59.999";
		
		// try {
		
			/**
			 * 3 cases here:
			 * 1. Valid date
			 * 2. Null value
			 * 3. Value of nullString - occurs when value is null from DB.......go figure.
			 */
			
			
			if(this.lineItemTreasuryPaymentDateFormatted == null) {
				return retVal;		// return default value
			}
			
			if(this.lineItemTreasuryPaymentDateFormatted.equals(nullString)) {
				return retVal;
			}
			
			return this.lineItemTreasuryPaymentDateFormatted;

		
	}	// end getLineItemTreasuryPaymentDateFormatted()


	/**
	 * @param lineItemTreasuryPaymentDateFormatted the lineItemTreasuryPaymentDateFormatted to set
	 */
	public void setLineItemTreasuryPaymentDateFormatted(String lineItemTreasuryPaymentDateFormatted) {
		this.lineItemTreasuryPaymentDateFormatted = lineItemTreasuryPaymentDateFormatted;
	}


	/**
	 * @return the lineItemPaidAmountFormatted
	 */
	@Override
	public String getLineItemPaidAmountFormatted() {
		
		return lineItemPaidAmountFormatted;
	}
	

	/**
	 * @param lineItemPaidAmountFormatted the lineItemPaidAmountFormatted to set
	 */
	@Override
	public void setLineItemPaidAmountFormatted(String lineItemPaidAmountFormatted) {
		this.lineItemPaidAmountFormatted = lineItemPaidAmountFormatted;
	}
	
	
	
	@Override
	public String getLineItemCheckNumber() {
			return lineItemCheckNumber;
		}
		
		
	@Override
	public void setLineItemCheckNumber(String lineItemCheckNumber) {
			this.lineItemCheckNumber = lineItemCheckNumber;
	}
	
	
	/**
	 * @param lineItemAdjAmts the lineItemAdjAmts to set
	 */
	@Override
	public void setLineItemAdjAmts(String lineItemAdjAmts) {
		this.lineItemAdjAmts = lineItemAdjAmts;
	}
	
	
	/**
	 * @return the lineItemAdjAmts
	 */
	@Override
	public String getLineItemAdjAmts() {
		return lineItemAdjAmts;
	}
	
	
	/**
	 * @return the lineItemCodes
	 */
	@Override
	public String getLineItemCodes() {
		return lineItemCodes;
	}
	

	/**
	 * @param lineItemCodes the lineItemCodes to set
	 */
	@Override
	public void setLineItemCodes(String lineItemCodes) {
		this.lineItemCodes = lineItemCodes;
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "ClaimPaymentBean [checkNumber=" + checkNumber
				+ ", adjReasonCodeOne=" + adjReasonCodeOne + ", adjAmtString="
				+ adjAmtString + ", treasuryPaymentDateFormatted="
				+ treasuryPaymentDateFormatted + ", paidAmountFormatted="
				+ paidAmountFormatted + ", lineItemCount=" + lineItemCount
				+ ", treasuryPaymentDate=" + treasuryPaymentDate
				+ ", treasuryPaymentAmount=" + treasuryPaymentAmount
				+ ", adjAmtOne=" + adjAmtOne + ", paidAmount=" + paidAmount
				+ ", lineItemTreasuryPaymentDate="
				+ lineItemTreasuryPaymentDate
				+ ", lineItemPaidAmountFormatted="
				+ lineItemPaidAmountFormatted + ", lineItemCheckNumber="
				+ lineItemCheckNumber + ", lineItemAdjAmts=" + lineItemAdjAmts
				+ ", lineItemCodes=" + lineItemCodes + ", claimIndex="
				+ claimIndex + "]";
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((adjAmtOne == null) ? 0 : adjAmtOne.hashCode());
		result = prime * result
				+ ((adjAmtString == null) ? 0 : adjAmtString.hashCode());
		result = prime
				* result
				+ ((adjReasonCodeOne == null) ? 0 : adjReasonCodeOne.hashCode());
		result = prime * result
				+ ((checkNumber == null) ? 0 : checkNumber.hashCode());
		result = prime * result + (int) (claimIndex ^ (claimIndex >>> 32));
		result = prime * result
				+ ((formatter == null) ? 0 : formatter.hashCode());
		result = prime * result
				+ ((lineItemAdjAmts == null) ? 0 : lineItemAdjAmts.hashCode());
		result = prime
				* result
				+ ((lineItemCheckNumber == null) ? 0 : lineItemCheckNumber
						.hashCode());
		result = prime * result
				+ ((lineItemCodes == null) ? 0 : lineItemCodes.hashCode());
		result = prime * result + lineItemCount;
		result = prime
				* result
				+ ((lineItemPaidAmountFormatted == null) ? 0
						: lineItemPaidAmountFormatted.hashCode());
		result = prime
				* result
				+ ((lineItemTreasuryPaymentDate == null) ? 0
						: lineItemTreasuryPaymentDate.hashCode());
		result = prime * result
				+ ((paidAmount == null) ? 0 : paidAmount.hashCode());
		result = prime
				* result
				+ ((paidAmountFormatted == null) ? 0 : paidAmountFormatted
						.hashCode());
		result = prime
				* result
				+ ((treasuryPaymentAmount == null) ? 0 : treasuryPaymentAmount
						.hashCode());
		result = prime
				* result
				+ ((treasuryPaymentDate == null) ? 0 : treasuryPaymentDate
						.hashCode());
		result = prime
				* result
				+ ((treasuryPaymentDateFormatted == null) ? 0
						: treasuryPaymentDateFormatted.hashCode());
		return result;
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof ClaimPaymentBean))
			return false;
		ClaimPaymentBean other = (ClaimPaymentBean) obj;
		if (adjAmtOne == null) {
			if (other.adjAmtOne != null)
				return false;
		} else if (!adjAmtOne.equals(other.adjAmtOne))
			return false;
		if (adjAmtString == null) {
			if (other.adjAmtString != null)
				return false;
		} else if (!adjAmtString.equals(other.adjAmtString))
			return false;
		if (adjReasonCodeOne == null) {
			if (other.adjReasonCodeOne != null)
				return false;
		} else if (!adjReasonCodeOne.equals(other.adjReasonCodeOne))
			return false;
		if (checkNumber == null) {
			if (other.checkNumber != null)
				return false;
		} else if (!checkNumber.equals(other.checkNumber))
			return false;
		if (claimIndex != other.claimIndex)
			return false;
		if (formatter == null) {
			if (other.formatter != null)
				return false;
		} else if (!formatter.equals(other.formatter))
			return false;
		if (lineItemAdjAmts == null) {
			if (other.lineItemAdjAmts != null)
				return false;
		} else if (!lineItemAdjAmts.equals(other.lineItemAdjAmts))
			return false;
		if (lineItemCheckNumber == null) {
			if (other.lineItemCheckNumber != null)
				return false;
		} else if (!lineItemCheckNumber.equals(other.lineItemCheckNumber))
			return false;
		if (lineItemCodes == null) {
			if (other.lineItemCodes != null)
				return false;
		} else if (!lineItemCodes.equals(other.lineItemCodes))
			return false;
		if (lineItemCount != other.lineItemCount)
			return false;
		if (lineItemPaidAmountFormatted == null) {
			if (other.lineItemPaidAmountFormatted != null)
				return false;
		} else if (!lineItemPaidAmountFormatted
				.equals(other.lineItemPaidAmountFormatted))
			return false;
		if (lineItemTreasuryPaymentDate == null) {
			if (other.lineItemTreasuryPaymentDate != null)
				return false;
		} else if (!lineItemTreasuryPaymentDate
				.equals(other.lineItemTreasuryPaymentDate))
			return false;
		if (paidAmount == null) {
			if (other.paidAmount != null)
				return false;
		} else if (!paidAmount.equals(other.paidAmount))
			return false;
		if (paidAmountFormatted == null) {
			if (other.paidAmountFormatted != null)
				return false;
		} else if (!paidAmountFormatted.equals(other.paidAmountFormatted))
			return false;
		if (treasuryPaymentAmount == null) {
			if (other.treasuryPaymentAmount != null)
				return false;
		} else if (!treasuryPaymentAmount.equals(other.treasuryPaymentAmount))
			return false;
		if (treasuryPaymentDate == null) {
			if (other.treasuryPaymentDate != null)
				return false;
		} else if (!treasuryPaymentDate.equals(other.treasuryPaymentDate))
			return false;
		if (treasuryPaymentDateFormatted == null) {
			if (other.treasuryPaymentDateFormatted != null)
				return false;
		} else if (!treasuryPaymentDateFormatted
				.equals(other.treasuryPaymentDateFormatted))
			return false;
		return true;
	}


	@Override
	public void setPaidAmountFormatted(BigDecimal paidAmount) {
		// TODO Auto-generated method stub
		
	}
	
	
	
	

}	// end ClaimPaymentBean()
