/*
 * $Id: ClaimRejectionHistoryEntity.java,v 1.1 2009/09/03 22:22:52 vhahacdoansc Exp $
 */
package gov.va.med.fee.claim;

import gov.va.med.domain.fee.ClaimQueue;
import gov.va.med.domain.fee.AdjustmentReason;

/**
 * The class ClaimRejectionHistoryEntity class holds data about the 
 * rejection history of a claim.
 */
@SuppressWarnings("serial")
public class ClaimRejectionHistoryEntity {

    private ClaimQueue rejection;
    private AdjustmentReason rejectionReason;
  
    

    /**
     * Creates a new instance of ClaimRejectionHistoryEntity.
     */
    public ClaimRejectionHistoryEntity() {
        rejection = new ClaimQueue();
        rejectionReason = new AdjustmentReason();
    }

    /**
     * Constructs a <code>ClaimRejectionHistoryEntity</code> given a <code>ClaimQueue</code>
     * and <code>AdjustmentReason</code> instance.
     * 
     * @param rejection
     *            The ClaimQueue associated with the claim
     * @param reason
     *            The AdjustmentReason information associated with the claim    
     */
    public ClaimRejectionHistoryEntity(ClaimQueue rejection, AdjustmentReason reason) {     
        this.rejection = rejection;
        this.rejectionReason = reason;
    }
    
    /**
     * Gets the rejection.
     * 
     * @return rejection.
     */
    public final ClaimQueue getRejection() {
        return this.rejection;
    }

    /**
     * Sets the rejection.
     * 
     * @param routing
     *          the ClaimQueue to set.
     */
    public final void setRejection(ClaimQueue rejection) {
        this.rejection = rejection;
    }

    
    /**
     * Gets the reason.
     * 
     * @return rejectionReason.
     */
    public final AdjustmentReason getRejectionReason() {
        return this.rejectionReason;
    }

    /**
     * Sets the reason.
     * 
     * @param rejectionReason
     *          the AdjustmentReason to set.
     */
    public final void setRejectionReason(AdjustmentReason rejectionReason) {
        this.rejectionReason = rejectionReason;
    }
}
