/*
 * $Id: ManualReconSelectionsBean.java,v 1.2 2010/09/22 21:44:21 vhahacdoansc Exp $
 */
package gov.va.med.fee.claim;



import static org.jboss.seam.ScopeType.SESSION;
import gov.va.med.domain.fee.AdjustmentGroup;
import gov.va.med.domain.fee.AdjustmentReason;
import gov.va.med.domain.fee.CalcMethod;
import gov.va.med.domain.fee.ClaimPaymentType;
import gov.va.med.domain.fee.ClaimProcStatus;
import gov.va.med.domain.fee.RemittanceRemark;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import javax.annotation.PostConstruct;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.hibernate.exception.SQLGrammarException;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Destroy;
import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.core.SeamResourceBundle;
import org.jboss.seam.log.Log;



/**
 * The Class ManualReconSelectionsBean.
 * 
 * 
 */
@Stateful
@Name("manualReconSelections")
@Scope(SESSION)
public class ManualReconSelectionsBean implements ManualReconSelections{
	
	
	boolean DEBUG = true;

	private SelectItem[] remitCode;
	private SelectItem[] remitCode2;
	private SelectItem[] remitCode3;
	private SelectItem[] remitCode4;
	private SelectItem[] remitCode5;
	
	String adjReason1_id = "";
	String adjReason2_id = "";
	String adjReason3_id = "";
	String adjReason4_id = "";
	String adjReason5_id = "";
	
	String curReasonId = "";
	String curAdjustmentCode = "";
	
	SelectItem[] curItems = null;
	
	List<?> allRemarksList = null;
	
	
    /** The Constant LINE_LENGTH_LIMIT. */
    private static final int LINE_LENGTH_LIMIT = 120;

    /** The log. */
    @Logger
    private Log log;

    /** The em. */
    @PersistenceContext
    private EntityManager em;

    
    @In(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
    @Out(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
    private Map<String, AdjustmentReason> adjReasonMap;

    
    @In(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
    @Out(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
    private Map<String, AdjustmentGroup> adjGroupMap;

  
     @SuppressWarnings({ "rawtypes", "unchecked" })
    private Map<String, ClaimPaymentType> paymentTypeMap;

    
     
     public List<?> getAllRemarksList() {
		return allRemarksList;
	}

	public void setAllRemarksList(List<?> allRemarksList) {
		this.allRemarksList = allRemarksList;
	}

	public SelectItem[] getCurItems() {
		return curItems;
	}

	public void setCurItems(SelectItem[] curItems) {
		this.curItems = curItems;
	}

	public String getCurReasonId() {
    	 if(DEBUG) {
    		 System.out.println("getCurReasonID() value is: " + this.curReasonId);
    	 }
		return curReasonId;
	}

	public void setCurReasonId(String curReasonId) {
		 if(DEBUG) {
    		 System.out.println("setCurReasonID() value is: " + curReasonId);
    	 }
		this.curReasonId = curReasonId;
	}

	public String getCurAdjustmentCode() {
		return curAdjustmentCode;
	}

	public void setCurAdjustmentCode(String curAdjustmentCode) {
		this.curAdjustmentCode = curAdjustmentCode;
	}

	
	   @Override
		public void valueChange(String reasonId, String componentName) {
			
			
	if(DEBUG) {
		System.out.println("ManualReconSelectionsBean.valueChange() - reasonId and component passed are: " + reasonId + ", " + componentName);
	}
			
	    		if(componentName.equalsIgnoreCase("adjReason1")) {
	        			
	    			if(this.getAdjReason1_id().equalsIgnoreCase(reasonId)) {
	    				if(DEBUG) {
	         				System.out.println("valueChange() - same reason passed as current reason - EXITING AND DOING NOTHING");
	        			}
	    				// this.curReasonId = reasonId;
	    				return;
	    			} else {
	    				this.setCurReasonId(reasonId);
	    				this.setAdjReason1_id(reasonId);
	    				
	    				if(DEBUG) {
	         				System.out.println("valueChange() - DIFFERENT reason passed as current reason: " + reasonId);
	        			}
	    				
	    				
	    				
	    				
	      				getManualReconRemitRemarks1();
	    			}
	        	}	// end reason1 check
	    		
	    		
	    		
	    		
	    		
	    		if(componentName.equalsIgnoreCase("adjReason2")) {
	    			this.setAdjReason2_id(reasonId);
	    			getManualReconRemitRemarks2();
	    		} 
	    		
	    		if(componentName.equalsIgnoreCase("adjReason3")) {
	    			this.setAdjReason3_id(reasonId);
	    			getManualReconRemitRemarks3();
	    		} 
	    		
	    		if(componentName.equalsIgnoreCase("adjReason4")) {
	    			this.setAdjReason4_id(reasonId);
	    			getManualReconRemitRemarks4();
	    		} 
	    		
	    		if(componentName.equalsIgnoreCase("adjReason5")) {
	    			this.setAdjReason5_id(reasonId);
	    			getManualReconRemitRemarks5();
	    		} 
	      		
	 	}	// end valueChange()
	
	
	
	
	
	@PostConstruct 
     public void intialize() {
 		/**
		     	if(DEBUG) {
		     		System.out.println("ManualReconSelectionsBean.initialize() adjReason1_id is: " + adjReason1_id);
		       	}
		     	
		     	try {
		 		   ManualReconEntity mrEntity = (ManualReconEntity) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("manualReconClaimBean");
		 		   
		 		   Map<String, Object> sObjects =  FacesContext.getCurrentInstance().getExternalContext().getSessionMap();
		
				   
				   Iterator entries = sObjects.entrySet().iterator();
				   	while (entries.hasNext()) {
			   	      Entry thisEntry = (Entry) entries.next();
			   	      Object key = thisEntry.getKey();
			   	      Object value = thisEntry.getValue();
			   	      
			   	      if(key.toString().equalsIgnoreCase("manualReconRemitRemarks1") ) {
				   	      System.out.println("manualReconRemitRemarks1 FOUND - Map key is: " + key.toString());
				   	      System.out.println("Map value is: " + value.toString());
			   	      }
		     	    }
		   	    
		   	    
				   if(sObjects.containsValue("manualReconRemitRemarks1")) {
					   sObjects.remove("manualReconRemitRemarks1");
					   if(DEBUG) {
						   System.out.println("ManualReconSelectionsBean.initialize() - manualReconRemitRemarks1 NOT FOUND");
					   }
					   
		     		} else {
		     			if(DEBUG) {
		 				   System.out.println("ManualReconSelectionsBean.initialize() - manualReconRemitRemarks1 NOT FOUND");
		 			   }
		     		}
		 		   
		 		   
		 		   if(mrEntity != null) {
		 			   // this.manualReconClaimBean = mrrcBean;
		 			   System.out.println("ManualReconSelectionsBean.initialize() - manualReconEntity found");
		 		   }	// end if
		 	    }catch(Exception e) {
		     		System.out.println("ManualReconSelectionsBean.initialize() - error setting reconRemitRemarks: " + e.getMessage());
		     		e.printStackTrace();
		     	}
		     	
		  **/   	
		     	
		     	
      }	// END intialize()
 	 
     @Destroy
	 @Remove
	   public final void destroy() {
	      // log.info("destroyed:" + this);
		 
		 if(DEBUG) {
		//	 System.out.println("ManualReconSelectionsBean.destroy() - nulling remitCodes and reasons.");
		 }
		 
		 /**
		 remitCode = null;
		 remitCode2 = null;
		 remitCode3 = null;
		 remitCode4 = null;
		 remitCode5 = null;
		 
		 this.adjReason1_id = "";
		 this.adjReason2_id = "";
		 this.adjReason3_id = "";
		 this.adjReason4_id = "";
		 this.adjReason5_id = "";
		 
		  Map<String, Object> sObjects =  FacesContext.getCurrentInstance().getExternalContext().getSessionMap();

			 
		  
		  if(sObjects.containsValue("manualReconRemitRemarks1")) {
				   sObjects.remove("manualReconRemitRemarks1");
				   if(DEBUG) {
					   System.out.println("ManualReconSelectionsBean.destroy() - manualReconRemitRemarks1 NOT FOUND");
				   }
				   
	     		} else {
	     			if(DEBUG) {
	 				   System.out.println("ManualReconSelectionsBean.destroy() - manualReconRemitRemarks1 NOT FOUND");
	 			   }
	     		}
			 
		 if(DEBUG) {
			 System.out.println("ManualReconSelectionsBean.destroy() - remitCodes and adjReasons cleared");
		 }
		 
		**/ 
	   }
     
 
    

	/**
	   * returns a list of remit remarks for a given adjustment
	   * @param adjCode
	   * @return
	   */
	  @SuppressWarnings("unchecked")
	private  SelectItem[] getRemitRemarks(String adjCode, int adjReasonId) {
			 
		  Date today = new Date();
		  
		  /**
		   * CALLS TO THIS MUST BE CONTROLLED...........HOW?
		   */
		    boolean DEBUG = true;
		    
		    if(DEBUG) {
		    	System.out.println("getRemitRemarks() - adjCode and adjReasonId are: " + adjCode + ", " + adjReasonId);
		    	System.out.println("getRemitRemarks() - current adjReasonId is: " + adjReasonId);
		    	
		    }
				    
		    if(adjCode.equalsIgnoreCase(this.curAdjustmentCode)) {
		    	if(DEBUG) {
			    	System.out.println("getRemitRemarks() - SAME CODE PASSED - RETURNING curitems" + this.curItems.hashCode());
		    	}
		    	
		    	return this.curItems;
		    } else {
		    	
		    	if(DEBUG) {
			    	System.out.println("getRemitRemarks() - different CODE PASSED - resetting curAdjustmentCode to: " + adjCode.hashCode());
		    	}
		    	this.curAdjustmentCode = adjCode;
		    }
		 
		    // curItems
		    
		    int size=1;
		    String[][] retItems = new String[size][2];
		    Iterator<?> it;
		    List<RemittanceRemark> ar = new ArrayList<RemittanceRemark>();
		    
		    
	       	try { 
						        	  // start and end dates not being recognized for some reason - class and db checked for existence
						        	  /**
						        	Query q = em.createQuery("select r from fRemittanceRemark r where :curDate BETWEEN r.startDate and r.endDate "
						            		+ "order by remittanceRemarkCd").setParameter("curDate", today);	
						        	**/

						        	  // REWRITE SQL TO GET PROPER LIST.

/**			        		
String sql = "SELECT DISTINCT REMITTANCE_REMARK.REMITTANCE_REMARK_CD, REMITTANCE_REMARK.DESCRIPTION, REMITTANCE_REMARK.FEE_USAGE_FLAG,"
			+ "REMITTANCE_REMARK.CREATED_BY, REMITTANCE_REMARK.START_DATE, REMITTANCE_REMARK.END_DATE, REMITTANCE_REMARK.DATE_CREATED, " +
								"ADJUSTMENT_REASON.ADJUSTMENT_REASON_CD "+ 
								"FROM  fpps_owner.REMITTANCE_REMARK, fpps_owner.ADJUSTMENT_REASON "+
"INNER JOIN ADJUSTMENT_REASON ADJ ON CARC_RARC_CROSSWALK.CARC_ID=ADJUSTMENT_REASON.ADJUSTMENT_REASON_CD " +
" INNER JOIN REMITTANCE_REMARK REM ON CARC_RARC_CROSSWALK.CARC_ID= REM.REMITTANCE_REMARK_CD " +
"WHERE CARC_RARC_CROSSWALK.CARC_ID = " + adjCode + " ORDER BY REMITTANCE_REMARK.DESCRIPTION";

/**
* select ....
from CARC_RARC_CROSSWALK cross
join Adjustment_reason adj on cross.carc_id = adj.adjustment_reason_cd
join remittance_remark rem on cross.rarc_id = rem.remittance_remark_cd
where ...

ERROR WITH ABOVE STATEMENT: "CARC_RARC_CROSSWALK"."CARC_ID": invalid identifier - GO FIGURE.
*/



/**
String sql = "SELECT DISTINCT REMITTANCE_REMARK.REMITTANCE_REMARK_CD, REMITTANCE_REMARK.DESCRIPTION, REMITTANCE_REMARK.FEE_USAGE_FLAG,"
				+ "REMITTANCE_REMARK.CREATED_BY, REMITTANCE_REMARK.START_DATE, REMITTANCE_REMARK.END_DATE, REMITTANCE_REMARK.DATE_CREATED, " +
									"ADJUSTMENT_REASON.ADJUSTMENT_REASON_CD "+ 
									"FROM  fpps_owner.REMITTANCE_REMARK, fpps_owner.ADJUSTMENT_REASON "+
									"INNER JOIN fpps_owner.CARC_RARC_CROSSWALK "+
									"ON CARC_RARC_CROSSWALK.CARC_ID=ADJUSTMENT_REASON.ADJUSTMENT_REASON_CD "+ 
									"WHERE CARC_RARC_CROSSWALK.CARC_ID = " + adjCode + " ORDER BY REMITTANCE_REMARK.DESCRIPTION";
**/


 String sql = "SELECT DISTINCT RR.REMITTANCE_REMARK_CD, RR.DESCRIPTION, RR.FEE_USAGE_FLAG, " +
 		 "RR.CREATED_BY, RR.START_DATE, RR.END_DATE, RR.DATE_CREATED " +
 " FROM " +
        "fpps_owner.REMITTANCE_REMARK RR, fpps_owner.CARC_RARC_CROSSWALK CWS " +
        "JOIN " +
        "fpps_owner.REMITTANCE_REMARK RR2 ON " +
        "CWS.RARC_ID=RR2.REMITTANCE_REMARK_CD " +
      	"JOIN " +
        "fpps_owner.ADJUSTMENT_REASON ARI ON " +
        " CWS.CARC_ID=ARI.ADJUSTMENT_REASON_CD " +
        " WHERE CWS.CARC_ID = "  +"'" + adjCode + "'" + 
        " AND :today between RR.START_DATE AND RR.END_DATE " +
        " ORDER BY RR.description";
 
if(DEBUG) {
//		System.out.println("sql is: " + sql);
}    
 
String sqlAll = "SELECT DISTINCT RR.REMITTANCE_REMARK_CD, RR.DESCRIPTION, RR.START_DATE, RR.END_DATE, " +
		 " CWS.RARC_ID AS CWS_RR_CD, CWS.CARC_ID AS CWS_CARC_ID " +
		 "FROM " +
		        "fpps_owner.REMITTANCE_REMARK RR, fpps_owner.CARC_RARC_CROSSWALK CWS " +
		        "JOIN " +
		        "fpps_owner.REMITTANCE_REMARK RR2 ON " +
		        "CWS.RARC_ID=RR2.REMITTANCE_REMARK_CD " +
		      	"JOIN " +
		        "fpps_owner.ADJUSTMENT_REASON ARI ON " +
		        "CWS.CARC_ID=ARI.ADJUSTMENT_REASON_CD " +
		        " WHERE :today between RR.START_DATE AND RR.END_DATE " +
				" ORDER BY RR.DESCRIPTION";
		

									@SuppressWarnings("rawtypes")
									Query q = null;
									
									
									q= em.createNativeQuery(sql); 
									q.setParameter("today", today);
									
									List<?> l = null;
									
									l = q.getResultList();
									
									
									// IF THERE ARE NO ASSOCIATED REMARKS, RETURN ALL RECORDS
									if(l.size() == 0) {
											l.clear();
										
											if(allRemarksList != null) {
												l = allRemarksList;
											} else {
												try {
													q= em.createNativeQuery(sqlAll); 
													q.setParameter("today", today);
													l = q.getResultList();
													allRemarksList = l;
												}catch(Exception y) {
													log.error(y);
													System.out.println("getRemitRemarks() - failed query for ALL RECORDS: " + y.getMessage());
													y.printStackTrace();
												}	// end try/catch
											}	// end allRemarksList check
									}	// end size check
										
									it = l.iterator();	
									
									String code = "";
									String description = "";
									/**
									char feeUsageFlag;
									String createdBy = "";
									Date startDate;
									Date endDate;
									Date dateCreated;
									**/
									
									// Date tmpDate;
									String tmp = "";
									
									while (it.hasNext()) {
										Object[] row = (Object[]) it.next();
										
										if(row != null) {
								        	// code
											code = (String) row[0];
											// description not required - check for nulls
											tmp = (String) row[1];
											
											if( (tmp != null) && (!tmp.isEmpty()) ) {
												description = tmp;
											} else {
												description = "";
											}
												/**
											startDate = toDate( (java.sql.Timestamp) row[4] );
											endDate = toDate( (java.sql.Timestamp) row[5] );
											dateCreated =  toDate( (java.sql.Timestamp) row[6]   )  ;
											**/
											
											RemittanceRemark rr = new RemittanceRemark();
											 rr.setRemittanceRemarkCd(code);
											 rr.setDescription(description);
											// rr.setStartDate(startDate);
											// rr.getEndDate();
											// rr.getDateCreated();
	if(DEBUG) {
	//	System.out.println("rr added to collection");
	}
											ar.add(rr);
												
									    }	// end if null check
										
									}	// end while record loop
									
								Map<String, RemittanceRemark>  remitRemarkMap = new LinkedHashMap<String, RemittanceRemark>(ar.size());
								    
								int size1 = remitRemarkMap.size();
								    
								String[][] items1 = new String[size1][2];
						            
								if( (ar != null) && (! (ar.isEmpty()) ) )  {				            
									    for (RemittanceRemark rr : ar) {
										    		remitRemarkMap.put(rr.getRemittanceRemarkCd(), rr);
									} 
								}
								
								int index = 0;
									try	{
											int mapSize = remitRemarkMap.size();
											items1 = new String[mapSize][2];
											for (RemittanceRemark rr : remitRemarkMap.values()) {
												try {
													items1[index][0] = rr.getRemittanceRemarkCd();
												    items1[index][1] = rr.getDescription();
												    index++;
												}catch(Exception xy) {
													log.error(xy);
													System.out.println("error with index: " + xy.getMessage());
												}
											    
											}
									}catch(Exception f) {
										log.error(f);
										System.out.println("error with items1 array: " + f.getMessage());
									}

if(DEBUG) {
	// System.out.println("getRemitRemarks() - items[] FILLED size is: " + items1.length);
}						            
									
									
									
								retItems = items1.clone();
								
								
if(DEBUG) {
	// System.out.println("getRemitRemarks() - retItems[] CLONED - size is: " + retItems.length);
}						            
					        	}catch(SQLGrammarException e) {
					        		log.error(e);
					        		System.out.println("getRemitRemarks() - ERROR W/SQL: " + e.getMessage());
					        		e.printStackTrace();
					        	} catch(Exception ex) {
					        		log.error(ex);
					        		System.out.println("getRemitRemarks() - ERROR : " + ex.getMessage());
					        		ex.printStackTrace();
					        	}
				        	
							   SelectItem[] items = convertToSelectItemArray(retItems, null);	
							   this.curItems = items;
					
   				
   if(DEBUG) {
	   System.out.println("getRemitRemarks() THE END - new curItems is: " + this.curItems.hashCode());
   }   				
   				
   				
   				
			    return items;
	  }	// end getRemitRemarks()
    

	    
    @Override
	public SelectItem[] getRemitCode2() {
		return remitCode2;
	}

	@Override
	public void setRemitCode2(SelectItem[] remitCode2) {
		this.remitCode2 = remitCode2;
		// this.manualReconClaimBean.
	}
	
	@Override
	public  SelectItem[] getRemitCode() {
		return this.remitCode;
	}

	@Override
	public void setRemitCode(SelectItem[] remitCode) {
		this.remitCode = remitCode;
	}

    
    
    
   
/**
	public Map<String, RemittanceRemark> getRemitRemarkMapAll() {
		return remitRemarkMapAll;
	}

	public void setRemitRemarkMapAll(Map<String, RemittanceRemark> remitRemarkMapAll) {
		this.remitRemarkMapAll = remitRemarkMapAll;
	}
**/
    
    public static java.util.Date toDate(java.sql.Timestamp timestamp) {
        long milliseconds = timestamp.getTime() + (timestamp.getNanos() / 1000000);
        return new java.util.Date(milliseconds);
    }

    

	
		
	
    public String getAdjReason1_id() {
		return adjReason1_id;
	}

	public void setAdjReason1_id(String adjReason1_id) {
		this.adjReason1_id = adjReason1_id;
	}

	public String getAdjReason2_id() {
		return adjReason2_id;
	}

	public void setAdjReason2_id(String adjReason2_id) {
		this.adjReason2_id = adjReason2_id;
	}

	 /**
	     * Gets the manual recon remit remarks for list 1.
	      *
	     * @return the manual recon remit remarks for list 1
	     * TO DO: changes SQL to return records for passed reason code.
	     * manualReconAdjRemitRemarks1
	     * 
	     */
	    @SuppressWarnings("unchecked")
	    @Factory(value = "manualReconRemitRemarks1", scope = ScopeType.CONVERSATION)
	    public SelectItem[] getManualReconRemitRemarks1() {
	    	
	 		   Map<String, Object> sObjects =  FacesContext.getCurrentInstance().getExternalContext().getSessionMap();

	    	// what can we check here to keep the query from being run again?
	     	// try {
		 		   // ManualReconEntity mrEntity = (ManualReconEntity) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("manualReconClaimBean");
		 		   
		 		   // trap phase value - exit if it is?
	 		   /**
		 		   try {
		 			   PhaseId pid = FacesContext.getCurrentInstance().getCurrentPhaseId();
		 			  if(DEBUG) {
			 			   System.out.println("getManualReconRemitRemarks1() - phase ID is: " + pid.toString());
			 		   }
		 		   }catch(Exception e) {
		 			   System.out.println("getManualReconRemitRemarks1() error getting PhaseId" + e.getMessage());
		 		   }
		 		**/   
		 		  
		 		   
		 		   /**
		 		   if (FacesContext.getCurrentInstance().getCurrentPhaseId() == PhaseId.RESTORE_VIEW) {
		 			    // Restore view called.
		 			}
		 			**/
		 		   
		 	/**	   
		 		   Map<String, Object> sObjects =  FacesContext.getCurrentInstance().getExternalContext().getSessionMap();
		
				   
				   Iterator entries = sObjects.entrySet().iterator();
				   	while (entries.hasNext()) {
			   	      Entry thisEntry = (Entry) entries.next();
			   	      Object key = thisEntry.getKey();
			   	      Object value = thisEntry.getValue();
			   	      
			   	      if(key.toString().equalsIgnoreCase("manualReconRemitRemarks1") ) {
				   	      System.out.println("manualReconRemitRemarks1 FOUND - Map key is: " + key.toString());
				   	      System.out.println("Map value is: " + value.toString());
			   	      }
		     	    }
		   	    
		   	    
				   if(sObjects.containsValue("manualReconRemitRemarks1")) {
					   sObjects.remove("manualReconRemitRemarks1");
					   if(DEBUG) {
						   System.out.println("ManualReconSelectionsBean.initialize() - manualReconRemitRemarks1 NOT FOUND");
					   }
					   
		     		} else {
		     			if(DEBUG) {
		 				   System.out.println("ManualReconSelectionsBean.initialize() - manualReconRemitRemarks1 NOT FOUND");
		 			   }
		     		}
		 		   
		 		   
		 		   if(mrEntity != null) {
		 			   // this.manualReconClaimBean = mrrcBean;
		 			   System.out.println("ManualReconSelectionsBean.initialize() - manualReconEntity found");
		 		   }	// end if
		 	    }catch(Exception e) {
		     		System.out.println("ManualReconSelectionsBean.initialize() - error setting reconRemitRemarks: " + e.getMessage());
		     		e.printStackTrace();
		     	}
	     	
	     	**/
		    	
			    	// check on Submit 
			    	   if( (adjReason1_id != null) && (!adjReason1_id.isEmpty()) ) {
			    		   
			    		   if(DEBUG) {
			    			   System.out.println("getManualReconRemitRemarks1() - calling getRemitRemarks");
			     		   }
			    		   
			    		   
						   SelectItem[] retVal = getRemitRemarks(adjReason1_id, 1);
						   this.setRemitCode(retVal);
						   // adjReason1_id = "";
						   return retVal;
					   } else {	
						     String[][] emptyList = new String[][] { {"", ""} };
				     		 SelectItem[] empty = convertToSelectItemArray(emptyList, null);
				     		// adjReason1_id = "";
				    		 this.setRemitCode(empty);
				    		 return empty;
					   }	// end if
			    	   
	      }	// END getManualReconRemitRemarks1()

	
	
	
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks2", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks2() {
		  
				  
		   if( (adjReason2_id != null) && (!adjReason2_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason2_id, 2);
			   this.setRemitCode2(retVal);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		this.setRemitCode(empty);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks2()
	  
	  
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks3", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks3() {
		  
		  if(DEBUG) {
			 System.out.println("\n\ngetManualReconRemitRemarks3()");
			 System.out.println("adjReason3_id is: " + this.getAdjReason3_id() );
		  }
		  
		  
		   if( (adjReason3_id != null) && (!adjReason3_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason3_id, 3);
			   System.out.println("getManualReconRemitRemarks3() - received retVal from getRemitRemarks size of: " + retVal.length);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		System.out.println("getManualReconRemitRemarks3() - empty adjustment reason - returning empty array");
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks3()
	  
	  
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks4", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks4() {
		  
		  if(DEBUG) {
			 System.out.println("\n\ngetManualReconRemitRemarks4()");
		  }
		  
		  
		   if( (adjReason4_id != null) && (!adjReason4_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason4_id, 4);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		 
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks4()
	  
	  
	  
	  @SuppressWarnings("unchecked")
	  @Factory(value = "manualReconRemitRemarks5", scope = ScopeType.CONVERSATION)
	  public SelectItem[] getManualReconRemitRemarks5() {
		  
		  if(DEBUG) {
			 System.out.println("getManualReconRemitRemarks5()");
		  }
		  
		  
		   if( (adjReason5_id != null) && (!adjReason5_id.isEmpty()) ) {
			   SelectItem[] retVal = getRemitRemarks(adjReason5_id, 5);
			   return retVal;
		   } else {	
			    String[][] emptyList = new String[][] {  {"", ""}  };
	    		SelectItem[] empty = convertToSelectItemArray(emptyList, null);
	    		return empty;
		   }
	  }	// end getManualReconRemitRemarks5()
	  
	  
	  
	  
	  
	  
	
	 
	  
	  
   

	// END OF NEW EVENT HANDING METHODS    
    /**
     * Gets the manual recon calc method.
     *
     * @return the manual recon calc method
     */
    @Factory(value = "manualReconCalcMethod", scope = ScopeType.SESSION)
    public final CalcMethod getManualReconCalcMethod() {
        CalcMethod calMethod = (CalcMethod) em
            .createQuery("from fCalcMethod where calcMethodCd = -2")
            .getSingleResult();
        
        if(DEBUG) {
        	System.out.println("ManualReconSelectionsBean.getManualReconCalcMethod()");
        }
        
        
        return calMethod;
    }

    /**
     * Gets the accepted claim proc status.
     *
     * @return the accepted claim proc status
     */
    @Factory(value = "acceptedClaimProcStatus", scope = ScopeType.SESSION)
    public final ClaimProcStatus getAcceptedClaimProcStatus() {
        ClaimProcStatus sps = (ClaimProcStatus) em
            .createQuery("from fClaimProcStatus where claimProcStatusCd = 'ACCEPTED'")
            .getSingleResult();
        
        if(DEBUG) {
        	System.out.println("ManualReconSelectionsBean.getAcceptedClaimProcStatus()");
        }
        
        return sps;
    }

    /**
     * Gets the claim payment type.
     *
     * @param paymentTypeCode the payment type code
     *
     * @return the claim payment type
     */
    public final ClaimPaymentType getClaimPaymentType(String paymentTypeCode) {
    	
    	 if(DEBUG) {
         	System.out.println("ManualReconSelectionsBean.getClaimPaymentType()");
         }
    	
        return paymentTypeMap.get(paymentTypeCode);
    }

    /**
     * Gets the remittance remarks.
     *
     * @param items the items
     *
     * @return the remittance remarks
     */
    
    /**
    @SuppressWarnings("unchecked")
    public final List<RemittanceRemark> getRemittanceRemarks1(String[] items) {
        List<RemittanceRemark> rrs = new ArrayList<RemittanceRemark>();
        if (items != null && items.length > 0) {
            for (int i = 0; i < items.length; i++) {
                rrs.add((RemittanceRemark) remitRemarkMap1.get(items[i]));
            }
        }
        
        if(DEBUG) {
        	System.out.println("ManualReconSelectionsBean.getRemittanceRemarks()");
        }
        
        return rrs;
    }
    **/

    /**
     * Gets the adjustment group.
     *
     * @param group the group
     *
     * @return the adjustment group
     */
    public final AdjustmentGroup getAdjustmentGroup(String group) {
        return adjGroupMap.get(group);
    }

    /**
     * Gets the adjustment reason.
     *
     * @param reason the reason
     *
     * @return the adjustment reason
     */
    public final AdjustmentReason getAdjustmentReason(String reason) {
        return adjReasonMap.get(reason);
    }

    /**
     * Gets the manual recon payment types.
     *
     * @return the manual recon payment types
     */
    @SuppressWarnings("unchecked")
    @Factory(value = "manualReconPaymentTypes", scope = ScopeType.PAGE)
    public final SelectItem[] getManualReconPaymentTypes() {
        if (paymentTypeMap == null) {
            Query q = em.createQuery("from fClaimPaymentType order by claimPaymentTypeCode");
            List<ClaimPaymentType> ar = q.getResultList();
            paymentTypeMap = new LinkedHashMap<String, ClaimPaymentType>(ar.size());
            for (ClaimPaymentType pt : ar) {
                paymentTypeMap.put(pt.getClaimPaymentTypeCode(), pt);
            }
            
            if(DEBUG) {
            	System.out.println("ManualReconSelectionsBean.getRemittanceRemarks()");
            }
            
            
        }

        int size = paymentTypeMap.size();
        String[][] items = new String[size][2];
        int index = 0;
        for (ClaimPaymentType pt : paymentTypeMap.values()) {
            items[index][0] = pt.getClaimPaymentTypeCode();
            items[index][1] = pt.getDescription();
            index++;
        }
        
        
        if(DEBUG) {
        	System.out.println("ManualReconSelectionsBean.getManualReconPaymentTypes()");
        }
        
        return convertToSelectItemArray(items,
                SeamResourceBundle.getBundle().getString("gov.va.med.fee.ManualRecon.SELECT_PAYMENT"));
    }

    @SuppressWarnings("unchecked")
    private void setupAdjReasonMap() {
        Query q = em.createQuery("from fAdjustmentReason a where a.activeFlag='Y'");
        List<AdjustmentReason> ar = q.getResultList();
        
        if(DEBUG) {
        	System.out.println("ManualReconSelectionsBean.setupAdjReasonMap()");
        }
        
        

        adjReasonMap = new LinkedHashMap<String, AdjustmentReason>(ar.size());
        Map<String, AdjustmentReason> sortedNumber = new TreeMap<String, AdjustmentReason>();
        Map<String, AdjustmentReason> sortedAlpha = new TreeMap<String, AdjustmentReason>();

        // Separate sorting numeric and alphanumeric codes
        for (AdjustmentReason reason : ar) {
            if (reason.getAdjustmentReasonCd().matches("^[A-Z].*")) {
                sortedAlpha.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
             } else {
                sortedNumber.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
             }
        }

        // Put back in the list without the padding.
        for (AdjustmentReason reason : sortedNumber.values()) {
            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
        }

        for (AdjustmentReason reason : sortedAlpha.values()) {
            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
        }
    }

    /**
     * Gets the manual recon adj reasons.
     *
     * @return the manual recon adj reasons
     */
    @Factory(value = "manualReconAdjReasons", scope = ScopeType.PAGE)
    public final SelectItem[] getManualReconAdjReasons() {
        if (adjReasonMap == null) {
            setupAdjReasonMap();
        }
        
        
if(DEBUG) {
	//System.out.println("ManualReconSelectionsBean.getManualReconAdjReasons()");
}
        
        
        int size = adjReasonMap.size();
        String[][] items = new String[size][2];
        int index = 0;
        for (AdjustmentReason reason : adjReasonMap.values()) {
            items[index][0] = reason.getAdjustmentReasonCd();
            items[index][1] = reason.getDescription();
            index++;
        }

        return convertToSelectItemArray(items, SeamResourceBundle.getBundle().getString("gov.va.med.fee.ManualRecon.SELECT_REASON"));
        
        
       // return convertToSelectItemArray(items, null);
        
        
    }

    /**
     * Gets the manual recon adj groups.
     *
     * @return the manual recon adj groups
     */
    @SuppressWarnings("unchecked")
    @Factory(value = "manualReconAdjGroups", scope = ScopeType.PAGE)
    public final SelectItem[] getManualReconAdjGroups() {
        if (adjGroupMap == null) {
            Query q = em.createQuery("from fAdjustmentGroup order by adjustmentGroupCd");
            List<AdjustmentGroup> ar = q.getResultList();
            adjGroupMap = new LinkedHashMap<String, AdjustmentGroup>(ar.size());
            for (AdjustmentGroup group : ar) {
                adjGroupMap.put(group.getAdjustmentGroupCd(), group);
            }
        }

        int size = adjGroupMap.size();
        String[][] items = new String[size][2];
        int index = 0;
        for (AdjustmentGroup group : adjGroupMap.values()) {
            items[index][0] = group.getAdjustmentGroupCd();
            items[index][1] = group.getDescription();
            index++;
        }
        
if(DEBUG) {
//	System.out.println("ManualReconSelectionsBean.getManualReconAdjGroups()");
}
        
        
        
       // return convertToSelectItemArray(items, null);
        
        return convertToSelectItemArray(items, SeamResourceBundle.getBundle().getString("gov.va.med.fee.ManualRecon.SELECT_GROUP"));
    }

   

    /**
     * Convert to select item array.
     *
     * @param items the items
     * @param selectText the select text
     *
     * @return the select item[]
     */
    private SelectItem[] convertToSelectItemArray(String[][] items, String selectText) {
        SelectItem[] ops = null;
        
        if (selectText != null) {
            if (items != null && items.length != 0) {
                ops = new SelectItem[items.length + 1];
                ops[0] = new SelectItem(null, selectText);
                for (int i = 0; i < items.length; i++) {
                    String key = items[i][0];
                    String value = items[i][1];
                    ops[i + 1] = new SelectItem(key, getDisplayValue(key, value));
                }
            } else {
                ops = new SelectItem[1];
                ops[0] = new SelectItem("0", selectText);
            }
        } else {
            if (items != null && items.length != 0) {
                ops = new SelectItem[items.length];
                for (int i = 0; i < items.length; i++) {
                    String key = items[i][0];
                    String value = items[i][1];
                    ops[i] = new SelectItem(key, getDisplayValue(key, value));
                }
            }
        }

        if(DEBUG) {
        //	System.out.println("ManualReconSelectionsBean.convertToSelectItemArray()");
        }
        
        return ops;
    }

    /**
     * Gets the display value.
     *
     * @param code the code
     * @param value the value
     *
     * @return the display value
     */
    private String getDisplayValue(String code, String value) {
        StringBuilder sb = new StringBuilder(code);
        sb.append(" - ").append(value);
        String ret = sb.length() > LINE_LENGTH_LIMIT ? sb.substring(0,
                LINE_LENGTH_LIMIT)
                + "..." : sb.toString();
          return ret;
    }

	
	
    
	 

	

	@Override
	public List<RemittanceRemark> getRemittanceRemarks(String[] remitCodes) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setManualReconAdjReasons(ValueChangeEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setManualReconAdjReasons(SelectItem[] items) {
		// TODO Auto-generated method stub
		
	}

	public String getAdjReason3_id() {
		return adjReason3_id;
	}

	public void setAdjReason3_id(String adjReason3_id) {
		this.adjReason3_id = adjReason3_id;
	}

	public String getAdjReason4_id() {
		return adjReason4_id;
	}

	public void setAdjReason4_id(String adjReason4_id) {
		this.adjReason4_id = adjReason4_id;
	}

	public String getAdjReason5_id() {
		return adjReason5_id;
	}

	public void setAdjReason5_id(String adjReason5_id) {
		this.adjReason5_id = adjReason5_id;
	}

	@Override
	public SelectItem[] getRemitCode3() {
		return this.remitCode3;
	}

	@Override
	public void setRemitCode3(SelectItem[] s) {
		this.remitCode3 = s;
	}

	@Override
	public SelectItem[] getRemitCode4() {
		return this.remitCode4;
	}

	@Override
	public void setRemitCode4(SelectItem[] s) {
		this.remitCode4 = s;
	}

	@Override
	public SelectItem[] getRemitCode5() {
		return this.remitCode5;
	}

	@Override
	public void setRemitCode5(SelectItem[] s) {
		this.remitCode5=s;
	}

	@Override
	public SelectItem[] getManualReconRemitRemarks() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void processValueChange(ValueChangeEvent event) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap1() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap1(Map<String, RemittanceRemark> remitRemarkMap1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap2() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap2(Map<String, RemittanceRemark> remitRemarkMap2) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap3() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap3(Map<String, RemittanceRemark> remitRemarkMap3) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap4() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap4(Map<String, RemittanceRemark> remitRemarkMap4) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Map<String, RemittanceRemark> getRemitRemarkMap5() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRemitRemarkMap5(Map<String, RemittanceRemark> remitRemarkMap5) {
		// TODO Auto-generated method stub
		
	}

	
	
	
}	// END OF CLASS
