package gov.va.med.fee.claim;

import gov.va.med.domain.fee.AdjustmentGroup;
import gov.va.med.domain.fee.AdjustmentReason;
import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.FeeClaimPayments;
import gov.va.med.domain.fee.FeeClaimPaymentLines;
import gov.va.med.domain.fee.ServiceType;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import gov.va.med.domain.fee.FeeClaimRouting;
import gov.va.med.domain.fee.AppUser;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.annotations.web.RequestParameter;
import org.jboss.seam.annotations.datamodel.DataModel;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import java.util.List;
import java.util.HashSet;
import java.util.ArrayList;
import static org.jboss.seam.ScopeType.SESSION;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.ScopeType;
import org.jboss.seam.international.StatusMessages;
import org.jboss.seam.international.StatusMessage.Severity;
import org.jboss.seam.log.Log;
import org.jboss.seam.annotations.Logger;

import gov.va.med.fee.Constants;
import gov.va.med.fee.sec.HomePageUserData;

import java.io.Serializable;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.math.BigDecimal;
import java.util.Date;
import javax.faces.event.ValueChangeEvent;
import javax.faces.context.FacesContext;
import gov.va.med.domain.fee.ClaimReconciliation;

/**
 * PaymentLineBean class.
 */

@Stateful
@Name("paymentLine")
@Scope(SESSION)

public class PaymentLineBean implements PaymentLine, Serializable  {
//public class ReconcileClaimBean implements ReconcileClaim, Serializable  {

	  @In(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
	  @Out(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
	  private Map<String, AdjustmentReason> adjReasonMap;
	
	  @In(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
	  @Out(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
	  private Map<String, AdjustmentGroup> adjGroupMap;	
	
	  /** The app user. */
	  @In(value = "appUser", required = true, scope = ScopeType.SESSION)
	  private AppUser appUser;	  

	  /** The homePageUserData bean. */
	  @In(value = "homePageUserData", required = false, scope = ScopeType.SESSION)
	  private HomePageUserData homePageUserData;	   
	   
	  @Out
	  private FeeClaimPaymentLines myLine;
	
	  /** The em. */
	  @PersistenceContext(unitName = "FPPS_Owner")
	  private EntityManager em;

      /** The log. */
      @Logger
      private Log log;
      
      
      public void clear(){
    	  myLine = new FeeClaimPaymentLines();
      }
      
      /**
       * Convert to select item array.
       *
       * @param items the items
       * @param selectText the select text
       *
       * @return the select item[]
       */
      private SelectItem[] convertToSelectItemArray(String[][] items,
              String selectText) {
          SelectItem[] ops = null;
          if (selectText != null) {
              if (items != null && items.length != 0) {
                  ops = new SelectItem[items.length + 1];
                  ops[0] = new SelectItem(null, selectText);
                  for (int i = 0; i < items.length; i++) {
                      String key = items[i][0];
                      String value = items[i][1];
                      ops[i + 1] = new SelectItem(key, getDisplayValue(key, value));
                  }
              } else {
                  ops = new SelectItem[1];
                  ops[0] = new SelectItem("0", selectText);
              }
          } else {
              if (items != null && items.length != 0) {
                  ops = new SelectItem[items.length];
                  for (int i = 0; i < items.length; i++) {
                      String key = items[i][0];
                      String value = items[i][1];
                      ops[i] = new SelectItem(key, getDisplayValue(key, value));
                  }
              }
          }

          return ops;
      }
      
      
	   @Override
	   @Transactional
	   // Copied from ReconcileClaimBean as the way I wanted to handle this is causing too many issue	   
	 public String editRow(String claimInd,
			 			 String feeInvoiceNum, String paymentLineId, String lineNum,String adjust1,
			 			 String adjustGroup1, String adjustReason1,String adjust2,
			 			 String adjustGroup2, String adjustReason2){
		  BigDecimal adjust1Decimal = null;
		  BigDecimal adjust2Decimal = null;
		  Query q = null;
		  FeeClaimPaymentLines hibernateLine = null;		  
		 

		  // Need to make sure we have a connection to the database that mYLine doesn't maintain
		  try{
			  
//			  if(myLine == null || myLine.getFeeClaimPaymentLineId() == null || myLine.getFeeClaimPaymentLineId().equals("") ){
				   q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.lineItemSequence = '" + lineNum + 
						   				"' AND fcpl.feeClaimPayments.claimIndex = '" + claimInd + "' AND fcpl.feeClaimPayments.feeInvoiceNumber = '" +
						   				feeInvoiceNum + "'");
				   hibernateLine = (FeeClaimPaymentLines) q.getSingleResult();
	//		  }
// The original idea behind this was to allow the person to create a payment line but as that is just not possible we need to make sure to throw an error				   
/*			  else{
				  q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.feeClaimPaymentLineId = '" + myLine.getFeeClaimPaymentLineId() +"'");
				  hibernateLine = (FeeClaimPaymentLines) q.getSingleResult();
			  }
*/			  
			  if(adjust1 != null && !"".equals(adjust1)){
				  adjust1Decimal = new BigDecimal(adjust1);
				  myLine.setAdjustmentAmount1(adjust1Decimal);
				  hibernateLine.setAdjustmentAmount1(adjust1Decimal);
			  }
			  if(adjust2 != null && !"".equals(adjust2)){
				  adjust2Decimal = new BigDecimal(adjust2);
				  myLine.setAdjustmentAmount2(adjust2Decimal);
				  hibernateLine.setAdjustmentAmount2(adjust2Decimal);
			  }		  		  
			  
			  if(lineNum != null && !"".equals(lineNum) ){
				  myLine.setLineItemSequence(lineNum);
				  hibernateLine.setLineItemSequence(lineNum);
				  
			  }
			  
			  if(adjust1Decimal != null && !"".equals(adjust1Decimal) ){
				  myLine.setAdjustmentAmount1(adjust1Decimal);
				  hibernateLine.setAdjustmentAmount1(adjust1Decimal);
			  }
			  if(adjust2Decimal != null && !"".equals(adjust2Decimal) ){
				  myLine.setAdjustmentAmount2(adjust2Decimal);
				  hibernateLine.setAdjustmentAmount2(adjust2Decimal);
			  }
			  if(adjustGroup1 != null && !"".equals(adjustGroup1) ){
				  myLine.setAdjustmentGroupCode1(adjustGroup1);
				  hibernateLine.setAdjustmentGroupCode1(adjustGroup1);
			  }
			  if(adjustGroup2 != null && !"".equals(adjustGroup2) ){
				  myLine.setAdjustmentGroupCode2(adjustGroup2);
				  hibernateLine.setAdjustmentGroupCode2(adjustGroup2);
			  }
			  if(adjustReason1 != null && !"".equals(adjustReason1) ){	  
				  myLine.setAdjustmentReasonCode1(adjustReason1);
				  hibernateLine.setAdjustmentReasonCode1(adjustReason1);
			  }
			  if(adjustReason2 != null && !"".equals(adjustReason2) ){	  
				  myLine.setAdjustmentReasonCode2(adjustReason2);
				  hibernateLine.setAdjustmentReasonCode2(adjustReason2);
			  }
	          java.util.Date today = new java.util.Date();
	          java.sql.Date sqlDate = new java.sql.Date(today.getTime());
			  
			  myLine.setDateModified(sqlDate);
			  hibernateLine.setDateModified(sqlDate);
			  myLine.setModifiedBy(appUser.getUserName());
      } catch (NoResultException resEx) {
         log.warn("No Result: {0} ", resEx.getMessage());
         StatusMessages.instance().addFromResourceBundle(Severity.ERROR, "gov.va.med.fee.payErrorRecon.PAYERROR_ON_NO_LINE_NUMBER", lineNum);
         return Constants.PAYERROR_FAILURE; 

      } catch (org.hibernate.QueryException qex) {
         log.error("Query Exception: {0} ", qex, qex.getMessage() );
         return Constants.PAYERROR_FAILURE;
      } catch (Exception ex) {
         log.error("Ex: {0}", ex, ex.getMessage());
         return Constants.PAYERROR_FAILURE;
      }
          return Constants.PAYERROR_SUCCESS;
	  }
      
      public String getAdjust1(){
    	  BigDecimal adjust1 = null;
    	  try{
    		  adjust1 = myLine.getAdjustmentAmount1();
    	  }
    	  catch(Exception e){
    		  log.error(e);
    	  }
    	  if(null != adjust1){
    		  return adjust1.toString();
    	  }
    	  return "";
      }

      
	    /**
	     * Gets the manual recon payment types.
	     *
	     * @return the manual recon payment types
	     */
	    @SuppressWarnings("unchecked")
	    @Factory(value = "payAdjustGroups", scope = ScopeType.PAGE)
	    public final SelectItem[] getAdjustGroups() {
	        if (adjGroupMap == null) {
	            Query q = em.createQuery("from fAdjustmentGroup order by adjustmentGroupCd");
	            List<AdjustmentGroup> ar = q.getResultList();
	            adjGroupMap = new LinkedHashMap<String, AdjustmentGroup>(ar.size());
	            for (AdjustmentGroup group : ar) {
	                adjGroupMap.put(group.getAdjustmentGroupCd(), group);
	            }
	        }

	        int size = adjGroupMap.size();
	        String[][] items = new String[size][2];
	        int index = 0;
	        for (AdjustmentGroup group : adjGroupMap.values()) {
	            items[index][0] = group.getAdjustmentGroupCd();
	            items[index][1] = group.getDescription();
	            index++;
	        }
	        return convertToSelectItemArray(items,Constants.SELECT_GROUP);
	    }

	    @Factory(value = "payAdjustReasons", scope = ScopeType.PAGE)
	    public final SelectItem[] getAdjustReasons() {
	        if (adjReasonMap == null) {
	            setupAdjReasonMap();
	        }
	        int size = adjReasonMap.size();
	        String[][] items = new String[size][2];
	        int index = 0;
	        for (AdjustmentReason reason : adjReasonMap.values()) {
	            items[index][0] = reason.getAdjustmentReasonCd();
	            items[index][1] = reason.getDescription();
	            index++;
	        }

	        return convertToSelectItemArray(items, Constants.SELECT_REASON);

	    }	    
	    
	    /**
	     * Gets the display value.
	     *
	     * @param code the code
	     * @param value the value
	     *
	     * @return the display value
	     */
	    private String getDisplayValue(String code, String value) {
	        StringBuilder sb = new StringBuilder(code);
	        sb.append(" - ").append(value);
	        String ret = sb.length() > Constants.LINE_LENGTH_LIMIT ? sb.substring(0,
	        		Constants.LINE_LENGTH_LIMIT)
	                + "..." : sb.toString();
	        return ret;
	    }
      
      
      
      public FeeClaimPaymentLines getLine(){
    	  // originally was using the local instance of the Line but thtat isn't getting the latest and greatest
    	  // to minimize DB impact will return myLine but may end up doing another call to bypass missing latest and greatest
    	  return myLine;
    	  
      }
      

	  public void setAdjust1(String adjust1){
		  BigDecimal adjust1Decimal = null;

		  try{
			  Query q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.feeClaimPaymentLineId = '" + myLine.getFeeClaimPaymentLineId() +"'");
			  FeeClaimPaymentLines hibernateLine = (FeeClaimPaymentLines) q.getSingleResult();
		  
		  	if(adjust1 != null && !"".equals(adjust1)){
			  adjust1Decimal = new BigDecimal(adjust1);
			  hibernateLine.setAdjustmentAmount1(adjust1Decimal);
			  myLine.setAdjustmentAmount1(adjust1Decimal);		  	
		  	}
		  } catch(NoResultException ex){
			  log.debug("No Result Exception for adjust one : {0} ", adjust1);
		  }		  	
		  
	  }


      
	  public void setLine(String line){
		  try{
			  Query q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.feeClaimPaymentLineId = '" + line +"'");
			  myLine = (FeeClaimPaymentLines) q.getSingleResult();
		  } catch(NoResultException ex){
			  log.warn("No Result Exception for : {0} ", line);
		  }
	  }	 	 

	   
	    @SuppressWarnings("unchecked")
	    private void setupAdjReasonMap() {
	        Query q = em.createQuery("from fAdjustmentReason a where a.activeFlag='Y'");
	        List<AdjustmentReason> ar = q.getResultList();

	        adjReasonMap = new LinkedHashMap<String, AdjustmentReason>(ar.size());
	        Map<String, AdjustmentReason> sortedNumber = new TreeMap<String, AdjustmentReason>();
	        Map<String, AdjustmentReason> sortedAlpha = new TreeMap<String, AdjustmentReason>();

	        // Separate sorting numeric and alphanumeric codes
	        for (AdjustmentReason reason : ar) {
	            if (reason.getAdjustmentReasonCd().matches("^[A-Z].*")) {
	                sortedAlpha.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
	             } else {
	                sortedNumber.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
	             }
	        }

	        // Put back in the list without the padding.
	        for (AdjustmentReason reason : sortedNumber.values()) {
	            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
	        }

	        for (AdjustmentReason reason : sortedAlpha.values()) {
	            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
	        }
	    }	  
	  
	  
	    /**
	     * Destroy.
	     */
	   @Remove
	  public final void destroy(){
        //NOOP
	  }  
	   	  	  
	  public PaymentLineBean(){
			myLine = new FeeClaimPaymentLines();
	  }
	  
	  public void radioChange(ValueChangeEvent valueChangeEvent) throws Exception{
		  log.debug("radio change");
	  }
 
}
