package gov.va.med.fee.claim;

import java.util.Date;
import java.math.BigDecimal;

/**
 * The class RerouteClaimListEntity class holds data for the list in 
 * the screen:
 * RerouteClaims
 */
@SuppressWarnings("serial")
public class RerouteClaimListEntity {
    
    private String claimIndex;
    private String vetName;
    private String providerName;
    private String billingProviderName;
    
  
  
    

    /**
     * Creates a new instance of ClaimListEntity.
     */
    public RerouteClaimListEntity() {
        
        claimIndex = "";
        vetName = "";
        providerName = "";
        billingProviderName = "";
    }

    /**
     * Constructs a <code>ClaimListEntity</code> given the parameters.
     * 
     * @param claimIndex
     *            The claimIndex
     * @param vetName
     *      the vet's name
     * @param providerName
     *      the provider name
     * @param totalLines
     *      the total number of line items
     * @param linesClosed
     *      the number of lines closed
     * @param assignedTo
     *      who it's assigned to
    */
    public RerouteClaimListEntity(String claimIndex,String vetName,String providerName, String billingProviderName) {     
    	this.claimIndex = claimIndex;
        this.vetName = vetName;
        this.providerName = providerName;
        this.billingProviderName = billingProviderName;
        
    }
    
    
    
   
    public void setClaimIndex(String claimIndex){this.claimIndex = claimIndex;}
    public String getClaimIndex(){return this.claimIndex;}
    
    public void setVetName(String vetName){this.vetName = vetName;}
    public String getVetName(){return this.vetName;}
    
    public void setProviderName(String providerName){this.providerName = providerName;}
    public String getProviderName(){return this.providerName;}
    
    public void setBillingProviderName(String billingProviderName){this.billingProviderName = billingProviderName;}
    public String getBillingProviderName(){return this.billingProviderName;}
}
