package gov.va.med.fee.claim;

import javax.ejb.Local;
import java.util.List;
import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import gov.va.med.domain.fee.FeeClaimRouting;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;
import javax.faces.event.ValueChangeEvent;
import javax.faces.component.UIData;
import java.util.HashMap;
import java.util.Map;
import javax.faces.model.SelectItem;
/**
 * The Interface RerouteClaims -interface for RerouteClaimBean session bean
 *
 * @author vhahacprestt
 */
@Local
public interface RerouteClaims {

    //methods for retrieval of destination data
    String getSelectedVisnId();
    void setSelectedVisnId(String selectedVisnId);
    String getFacilityId();
    void setFacilityId(String selectedFacilityId);
    String getUserName();
    void setUserName(String userName);

    List<SelectItem> getVisnList();

    List<SelectItem> getFacilitiesList();

    List<SelectItem> getUserList();

    /**
     * event handler for performing destination lookup
     */
    void changeFacilities();

    /**
     * update facility users list
     */
    void changeUsers();

    /**
     * Gets the sort column associated with the claim search.
     *
     * @return the sort column associated with the claim search.
     */
    String getSortCol();

    String getNonRouted();

    String getPrintedClaimsStr();

    /**
     * Sets the sort column associated with the claim search.
     *
     * @param sortCol
     *             the sort column.
     */
    void setSortCol(String sortCol);

    /**
     * Gets the sort direction associated with the claim search.
     *
     * @return the sort direction associated with the claim search.
     */
    String getSortDir();

    /**
     * Sets the sort direction associated with the claim search.
     * @param sortDir
     *            the sort direction.
     */
    void setSortDir(String sortDir);

// factory method for retrieving list of claim IDs
    void populateReroutes();

    public String getSelectedClaimId();

    public void setSelectedClaimId(String selectedClaimId);

    public String getReason();
    public void setReason(String reason);

    public List<SelectItem> getRerouteReasons();

    /**
    * retrieves recipient of rerouted claim (VISN/Facility/user)
    * @return destination
    */
    public String getDestination();

    public void setDestination(String destination);

    public String getComment();

    public void setComment(String comment);

    public boolean hasAccess(String userName, String bene);

    public String reroute();

    public boolean hasRole(String role);

    //we don't need this as this is injected
    //public String getSelectedClaims();
    /**
    * Destroy.
    */
    //void destroy();
}
