package gov.va.med.fee.claim;

import gov.va.med.domain.fee.AdjustmentGroup;
import gov.va.med.domain.fee.AdjustmentReason;
import gov.va.med.domain.fee.Claim;
import gov.va.med.domain.fee.ClaimPaymentType;
import gov.va.med.domain.fee.FeeClaimPayments;
import gov.va.med.domain.fee.FeeClaimPaymentLines;
import gov.va.med.domain.fee.ServiceType;
import gov.va.med.domain.fee.PersonInfo;
import gov.va.med.domain.fee.ProviderInfo;
import gov.va.med.domain.fee.FeeClaimRouting;
import gov.va.med.domain.fee.ClaimProcedure;
import gov.va.med.domain.fee.AppUser;
import gov.va.med.fee.Page;
import gov.va.med.fee.PageControls;

import org.jboss.seam.annotations.Factory;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Transactional;
import org.jboss.seam.annotations.web.RequestParameter;
import org.jboss.seam.annotations.datamodel.DataModel;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.faces.event.ValueChangeEvent;
import java.util.List;
import java.util.HashSet;
import java.util.ArrayList;
import static org.jboss.seam.ScopeType.SESSION;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.ScopeType;
import org.jboss.seam.log.Log;
import org.jboss.seam.annotations.Logger;
import org.jboss.seam.annotations.Synchronized;



import gov.va.med.fee.Constants;

import java.io.Serializable;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.math.BigDecimal;
import java.util.Date;
import javax.faces.event.ValueChangeEvent;
import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;
import gov.va.med.domain.fee.ClaimReconciliation;

/**
 * PaymentLineBean class.
 */

@Stateful
@Name("unmatchedClaim")
@Scope(SESSION)
@Synchronized(timeout=300000L)
public class UnmatchedClaimBean extends ReconcileClaimBean implements UnmatchedClaim, Serializable  {

    @In(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
    @Out(value = "adjReasonMap", required = false, scope = ScopeType.SESSION)
    private Map<String, AdjustmentReason> adjReasonMap;

    @In(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
    @Out(value = "adjGroupMap", required = false, scope = ScopeType.SESSION)
    private Map<String, AdjustmentGroup> adjGroupMap;
	
	/** The app user. */
	   @In(value = "appUser", required = true, scope = ScopeType.SESSION)
	   private AppUser appUser;	  

	   
	  private FeeClaimPaymentLines myLine;

	  private FeeClaimPayments myPayment;

//	   @In(value = "reconcileClaim", required = false, scope = ScopeType.SESSION)
//	   private ReconcileClaimBean reconcileClaim;	 
	  
	  private FeeClaimPayments searchLine;
	  
	  private String drgWeight = "";
	  private String billedAmount = "";
	  private String paidAmount = "";
	  
	  public void setDrgWeight(String s){this.drgWeight = s;}
	  public void setBilledAmount(String s){this.billedAmount = s;}
	  public void setPaidAmount(String s){this.paidAmount = s;}
	  
	  public String getDrgWeight(){return this.drgWeight;}
	  public String getBilledAmount(){return this.billedAmount;}
	  public String getPaidAmount(){return this.paidAmount;}
	  
	  // This will have to be changed to paymentLines but to get it going
	  // we will set it to paymentList
	  private List<FeeClaimPayments> paymentList;
	
	  /** The em. */
	  @PersistenceContext(unitName = "FPPS_Owner")
	  private EntityManager em;

      /** The log. */
      @Logger
      private Log log;
      
      
      public void clear(){
    	  myLine = new FeeClaimPaymentLines();
    	  myPayment = new FeeClaimPayments();
    	  this.paymentList.clear();  //added by scott 11/13/2009
      }

      /**
       * Convert to select item array.
       *
       * @param items the items
       * @param selectText the select text
       *
       * @return the select item[]
       */
      private SelectItem[] convertToSelectItemArray(String[][] items,
              String selectText) {
          SelectItem[] ops = null;
          if (selectText != null) {
              if (items != null && items.length != 0) {
                  ops = new SelectItem[items.length + 1];
                  ops[0] = new SelectItem(null, selectText);
                  for (int i = 0; i < items.length; i++) {
                      String key = items[i][0];
                      String value = items[i][1];
                      ops[i + 1] = new SelectItem(key, getDisplayValue(key, value));
                  }
              } else {
                  ops = new SelectItem[1];
                  ops[0] = new SelectItem("0", selectText);
              }
          } else {
              if (items != null && items.length != 0) {
                  ops = new SelectItem[items.length];
                  for (int i = 0; i < items.length; i++) {
                      String key = items[i][0];
                      String value = items[i][1];
                      ops[i] = new SelectItem(key, getDisplayValue(key, value));
                  }
              }
          }

          return ops;
      }
      
      
	   @Transactional
	   // Copied from ReconcileClaimBean as the way I wanted to handle this is causing too many issue	   
	 public String editRow(String paymentLineId, String lineNum,String adjust1,
			 			 String adjustGroup1, String adjustReason1,String adjust2,
			 			 String adjustGroup2, String adjustReason2, String inClaimIndex){
		  BigDecimal adjust1Decimal = null;
		  BigDecimal adjust2Decimal = null; 	  
		  Claim hibernateClaim = new Claim();
		  FeeClaimPaymentLines hibernateLine = new FeeClaimPaymentLines();
		  FeeClaimPayments hibernatePayment = new FeeClaimPayments();


		  // Need to make sure we have a connection to the database that mYLine doesn't maintain
		  try{
			  Query q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.feeClaimPaymentLineId = '" + paymentLineId +"'");
			  hibernateLine = (FeeClaimPaymentLines) q.getSingleResult();
			  
			  // Now need to also set the FeeClaimPayment to be associated with the claim
			  q = em.createQuery("select fcp from fFeeClaimPayments fcp where fcp.feeClaimPaymentId = '" + hibernateLine.getFeeClaimPayments().getFeeClaimPaymentId() + "'");
			  hibernatePayment = (FeeClaimPayments) q.getSingleResult();
			  
			  q = em.createQuery("Select cl from fClaim cl where cl.claimIndex = '" +inClaimIndex + "'");
			  hibernateClaim = (Claim) q.getSingleResult();
			  
			  hibernatePayment.setClaimIndex(Long.valueOf(inClaimIndex) );
	/*		  reconcileClaim.getPayments().add(myPayment );
			  reconcileClaim.setPayments( reconcileClaim.getPayments()  );
	*/
			  
			  
			  
			  if(adjust1 != null && !"".equals(adjust1)){
				  adjust1Decimal = new BigDecimal(adjust1);
				  myLine.setAdjustmentAmount1(adjust1Decimal);
				  hibernateLine.setAdjustmentAmount1(adjust1Decimal);
			  }
			  if(adjust2 != null && !"".equals(adjust2)){
				  adjust2Decimal = new BigDecimal(adjust2);
				  myLine.setAdjustmentAmount2(adjust2Decimal);
				  hibernateLine.setAdjustmentAmount2(adjust2Decimal);
			  }		  		  
			  
			  if(lineNum != null && !"".equals(lineNum) ){
				  myLine.setLineItemSequence(lineNum);
				  hibernateLine.setLineItemSequence(lineNum);
				  
			  }
			  
			  if(adjust1Decimal != null && !"".equals(adjust1Decimal) ){
				  myLine.setAdjustmentAmount1(adjust1Decimal);
				  hibernateLine.setAdjustmentAmount1(adjust1Decimal);
			  }
			  if(adjust2Decimal != null && !"".equals(adjust2Decimal) ){
				  myLine.setAdjustmentAmount2(adjust2Decimal);
				  hibernateLine.setAdjustmentAmount2(adjust2Decimal);
			  }
			  if(adjustGroup1 != null && !"".equals(adjustGroup1) ){
				  myLine.setAdjustmentGroupCode1(adjustGroup1);
				  hibernateLine.setAdjustmentGroupCode1(adjustGroup1);
			  }
			  if(adjustGroup2 != null && !"".equals(adjustGroup2) ){
				  myLine.setAdjustmentGroupCode2(adjustGroup2);
				  hibernateLine.setAdjustmentGroupCode2(adjustGroup2);
			  }
			  if(adjustReason1 != null && !"".equals(adjustReason1) ){	  
				  myLine.setAdjustmentReasonCode1(adjustReason1);
				  hibernateLine.setAdjustmentReasonCode1(adjustReason1);
			  }
			  if(adjustReason2 != null && !"".equals(adjustReason2) ){	  
				  myLine.setAdjustmentReasonCode2(adjustReason2);
				  hibernateLine.setAdjustmentReasonCode2(adjustReason2);
			  }
	          java.util.Date today = new java.util.Date();
	          java.sql.Date sqlDate = new java.sql.Date(today.getTime());
			  
			  myLine.setDateModified(sqlDate);
			  hibernateLine.setDateModified(sqlDate);
			  myLine.setModifiedBy(appUser.getUserName());
			  
			  this.clear(); //added by scott 11/13/2009
		  } catch(NoResultException ex){
			  return Constants.UNMATCHED_CLAIM_FAILURE;
		  }
		  return Constants.UNMATCHEDCLAIM_SUCCESS;
			  
	  }
      
	    /**
	     * Gets the manual recon payment types.
	     *
	     * @return the manual recon payment types
	     */
	    @SuppressWarnings("unchecked")
	    @Factory(value = "adjustGroups", scope = ScopeType.PAGE)
	    public final SelectItem[] getAdjustGroups() {
	        if (adjGroupMap == null) {
	            Query q = em.createQuery("from fAdjustmentGroup order by adjustmentGroupCd");
	            List<AdjustmentGroup> ar = q.getResultList();
	            adjGroupMap = new LinkedHashMap<String, AdjustmentGroup>(ar.size());
	            for (AdjustmentGroup group : ar) {
	                adjGroupMap.put(group.getAdjustmentGroupCd(), group);
	            }
	        }

	        int size = adjGroupMap.size();
	        String[][] items = new String[size][2];
	        int index = 0;
	        for (AdjustmentGroup group : adjGroupMap.values()) {
	            items[index][0] = group.getAdjustmentGroupCd();
	            items[index][1] = group.getDescription();
	            index++;
	        }
	        return convertToSelectItemArray(items,Constants.SELECT_GROUP);
	    }

	    @Factory(value = "adjustReasons", scope = ScopeType.PAGE)
	    public final SelectItem[] getAdjustReasons() {
	        if (adjReasonMap == null) {
	            setupAdjReasonMap();
	        }
	        int size = adjReasonMap.size();
	        String[][] items = new String[size][2];
	        int index = 0;
	        for (AdjustmentReason reason : adjReasonMap.values()) {
	            items[index][0] = reason.getAdjustmentReasonCd();
	            items[index][1] = reason.getDescription();
	            index++;
	        }

	        return convertToSelectItemArray(items, Constants.SELECT_REASON);

	    }	    
	    
	    /**
	     * Gets the display value.
	     *
	     * @param code the code
	     * @param value the value
	     *
	     * @return the display value
	     */
	    private String getDisplayValue(String code, String value) {
	        StringBuilder sb = new StringBuilder(code);
	        sb.append(" - ").append(value);
	        String ret = sb.length() > Constants.LINE_LENGTH_LIMIT ? sb.substring(0,
	        		Constants.LINE_LENGTH_LIMIT)
	                + "..." : sb.toString();
	        return ret;
	    }
	    
	    
 	  public FeeClaimPayments getClaimPayment(){
 		  	return myPayment;
 	  }
 	  
 	  public List<FeeClaimPayments> getPaymentList(){
 		  if(paymentList == null){
 			  	paymentList = new ArrayList<FeeClaimPayments>();
 			  	paymentList.clear();
 		  }
 		  return paymentList;
 	  }
 	  
 	@SuppressWarnings("unchecked")
	public List<FeeClaimPaymentLines> getPaymentLinesList(){
	 	   List<FeeClaimPaymentLines> paymentLinesList;
	 	   List<FeeClaimPaymentLines> feeClaimPaymentLines = null;
	 		 
	 	   if(myPayment != null & myPayment.getClaimIndex() != 0){
	 		 Query q = em.createQuery("select feeClaimPaymentLines from fFeeClaimPayments fcp where fcp.feeClaimPaymentId = '" + myPayment.getFeeClaimPaymentId() + "'");
	 		 feeClaimPaymentLines = (List<FeeClaimPaymentLines>) q.getResultList();
	 	   }
	 	   else{
	 		 return null;
	 	   }

		   // now do a selection sort to order the items correctly (perhaps not the most efficient -should even be done
		   // in db but this bypasses hibernate sorting problems at least.
		   Object[] paymentLineArray;		 
		   int listSize = feeClaimPaymentLines.size();
		   paymentLineArray = feeClaimPaymentLines.toArray();
		   // Need to initialize and then clear the list.
		   paymentLinesList = new LinkedList<FeeClaimPaymentLines>(feeClaimPaymentLines);
		   paymentLinesList.clear();
		   for(int i = 0; i < listSize; i++){
			   for(int j = 0; j < listSize; j++){
				   if( ( ( (FeeClaimPaymentLines) paymentLineArray[j]).getLineItemSequence().equals("ALL") ) ||
				   			(Integer.parseInt( ( (FeeClaimPaymentLines) paymentLineArray[j]).getLineItemSequence()) == (i+1))){
					   paymentLinesList.add((FeeClaimPaymentLines) paymentLineArray[j]);
					   break;
				   }
			   }
		   }
		  return paymentLinesList;
 	  }
 	  
 	  public FeeClaimPayments getSearchLine(){
 		  return searchLine;
 	  }

      public FeeClaimPaymentLines getLine(){
    	  // originally was using the local instance of the Line but thtat isn't getting the latest and greatest
    	  // to minimize DB impact will return myLine but may end up doing another call to bypass missing latest and greatest
    	  return myLine;
    	  
      }

      
    
	@SuppressWarnings("unchecked")
	public void search(){
		 boolean addp1 = false;
		 boolean addp2 = false;
		 
   		 String sqlStr = new String("select fcp from fFeeClaimPayments fcp where fcp.dateCreated != null");
   		 if(searchLine.getTransactionTypeCode() != null && searchLine.getTransactionTypeCode() != ""
   			 	&& !searchLine.getTransactionTypeCode().equals("%") ){
   			 sqlStr += " and fcp.transactionTypeCode = '" + searchLine.getTransactionTypeCode() + "'";
   		 }
   		 
   		 
   		 
   		 /*if(searchLine.getBilledAmount() != null && searchLine.getBilledAmount().toString() != "" 
   			 	&& !searchLine.getBilledAmount().equals("%") ){
   			 sqlStr += " and fcp.billedAmount = " + searchLine.getBilledAmount().toString();
   		 }*/
   		if(this.billedAmount != null 
   				&& this.billedAmount != "" 
			 	&& !this.billedAmount.equals("%") 
			 	&& !this.billedAmount.equals("_") ){
   			
   			 if(this.billedAmount.contains("%") || this.billedAmount.contains("_"))
   				 sqlStr += " and fcp.billedAmount LIKE '" + this.billedAmount + "'";
   			 else
   				 sqlStr += " and fcp.billedAmount = " + this.billedAmount;
		 } 
   		 
   		if(this.paidAmount != null 
   				&& this.paidAmount != "" 
			 	&& !this.paidAmount.equals("%") 
			 	&& !this.paidAmount.equals("_") ){
   			
   			 if(this.paidAmount.contains("%") || this.paidAmount.contains("_"))
   				 sqlStr += " and fcp.paidAmount LIKE '" + this.paidAmount + "'";
   			 else
   				 sqlStr += " and fcp.paidAmount = " + this.paidAmount;
		 } 
   		 
   		if(this.drgWeight != null 
   				&& this.drgWeight != "" 
			 	&& !this.drgWeight.equals("%") 
			 	&& !this.drgWeight.equals("_") ){
   			
   			 if(this.drgWeight.contains("%") || this.drgWeight.contains("_"))
   				 sqlStr += " and fcp.diagnosisRelatedGroupWeight LIKE '" + this.drgWeight + "' ";
   			 else
   				 sqlStr += " and fcp.diagnosisRelatedGroupWeight = " + this.drgWeight;
		 } 
   		 
   		 /*if(searchLine.getFeeInvoiceNumber() != null && searchLine.getFeeInvoiceNumber().toString() != ""
   			    && !searchLine.getFeeInvoiceNumber().toString().equals("%") ){
   			 sqlStr += " and fcp.feeInvoiceNumber = '" + searchLine.getFeeInvoiceNumber().toString() + "' ";   			 
   		 }*/
   		 
   		if(searchLine.getFeeInvoiceNumber() != null 
   				&& searchLine.getFeeInvoiceNumber() != "" 
			 	&& !searchLine.getFeeInvoiceNumber().equals("%") 
			 	&& !searchLine.getFeeInvoiceNumber().equals("_") ){
   			 
   			 addp1 = true;
   			 if(searchLine.getFeeInvoiceNumber().contains("%") || searchLine.getFeeInvoiceNumber().contains("_"))   				 
   			 	 sqlStr += " and fcp.feeInvoiceNumber LIKE :fin ";
   			 else   				 
   			 	 sqlStr += " and fcp.feeInvoiceNumber = :fin ";
		 } 
   		 
   		 
   		 
   		 
   		 /*if(searchLine.getDiagnosisRelatedGroupCode() != null && searchLine.getDiagnosisRelatedGroupCode() != ""
   			 	&& !searchLine.getDiagnosisRelatedGroupCode().equals("%") ){
   			 sqlStr +=" and fcp.diagnosisRelatedGroupCode = '" + searchLine.getDiagnosisRelatedGroupCode().toString() + "' ";   			 
   		 }*/
   		 
   		if(searchLine.getDiagnosisRelatedGroupCode() != null 
   				&& searchLine.getDiagnosisRelatedGroupCode() != "" 
			 	&& !searchLine.getDiagnosisRelatedGroupCode().equals("%") 
			 	&& !searchLine.getDiagnosisRelatedGroupCode().equals("_") ){
   			
   			 addp2 = true;
   			 if(searchLine.getDiagnosisRelatedGroupCode().contains("%") || searchLine.getDiagnosisRelatedGroupCode().contains("_"))
   				 sqlStr += " and fcp.diagnosisRelatedGroupCode LIKE :drgc ";
   			 else
   				 sqlStr += " and fcp.diagnosisRelatedGroupCode = :drgc ";
		 } 
   		 
   		 
   		 
   		 if(searchLine.getResolutionStatusCode() != null && searchLine.getResolutionStatusCode() != ""
   			 	&& !searchLine.getResolutionStatusCode().equals("%") ){
   			 sqlStr += " and fcp.resolutionStatusCode = '" + searchLine.getResolutionStatusCode() + "' ";
   		 }
   		    		    		   		
   		 if(searchLine.getFeeInvoiceDate() != null && searchLine.getFeeInvoiceDate().toString() != ""
   			 	&& !searchLine.getFeeInvoiceDate().toString().equals("%") ){
       	      /* Append the lower claim date range to the SQL statement */
   	         sqlStr += " AND fcp.feeInvoiceDate = TO_DATE('" + String.format("%1$tm/%1$td/%1$tY", searchLine.getFeeInvoiceDate()) 
                      + "', 'MM/dd/yyyy')"; 
   		 }
   		 
   		 
   		 sqlStr += " AND ROWNUM < 101 ";
   		 Query q = em.createQuery(sqlStr);
   		 
   		 if(addp1)
   			 q.setParameter("fin", searchLine.getFeeInvoiceNumber());
   		 if(addp2)
  			 q.setParameter("drgc", searchLine.getDiagnosisRelatedGroupCode());
   		
   		 paymentList = (List<FeeClaimPayments>) q.getResultList();

   	 }
	 public void setClaimPayment(String paymentId){
		 try{
			 Query q = em.createQuery("Select fcp from fFeeClaimPayments fcp where fcp.feeClaimPaymentId = '" + paymentId + "'");
			 myPayment = (FeeClaimPayments) q.getSingleResult();
		 } catch(NoResultException ex){
			log.warn("NoResultException in UnmatchedClaimBean.setClaimPayment for claim payment Id {0} ", paymentId);
		 }
		 
	 }
       	 
   	 public void setClaimPayment(FeeClaimPayments fcp){
   		 myPayment = fcp;
   	 }
   	 
   	public void setPaymentList(List<FeeClaimPayments> fcpList){
   		paymentList = fcpList;
   	}       	 
      
	  public void setLine(String line){
		  try{
			  Query q = em.createQuery("select fcpl from fFeeClaimPaymentLines fcpl where fcpl.feeClaimPaymentLineId = '" + line +"'");
			  myLine = (FeeClaimPaymentLines) q.getSingleResult();
		  } catch(NoResultException ex){
			  log.warn("NoResultException in  UnmatchedClaimBean.setLine for line: {0} ", line);
		  }
	  }	 	 
	  
	  
	  public void setSearchLine(FeeClaimPayments fcpl){
		  searchLine = fcpl;
	  }
	   
	    @SuppressWarnings("unchecked")
	    private void setupAdjReasonMap() {
	        Query q = em.createQuery("from fAdjustmentReason ar where ar.activeFlag='Y'");
	        List<AdjustmentReason> ar = q.getResultList();

	        adjReasonMap = new LinkedHashMap<String, AdjustmentReason>(ar.size());
	        Map<String, AdjustmentReason> sortedNumber = new TreeMap<String, AdjustmentReason>();
	        Map<String, AdjustmentReason> sortedAlpha = new TreeMap<String, AdjustmentReason>();

	        // Separate sorting numeric and alphanumeric codes
	        for (AdjustmentReason reason : ar) {
	            if (reason.getAdjustmentReasonCd().matches("^[A-Z].*")) {
	                sortedAlpha.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
	             } else {
	                sortedNumber.put(String.format("%3s", reason.getAdjustmentReasonCd()), reason);
	             }
	        }

	        // Put back in the list without the padding.
	        for (AdjustmentReason reason : sortedNumber.values()) {
	            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
	        }

	        for (AdjustmentReason reason : sortedAlpha.values()) {
	            adjReasonMap.put(reason.getAdjustmentReasonCd().trim(), reason);
	        }
	    }	  
	  
	  
	  public UnmatchedClaimBean(){
		  myLine = new FeeClaimPaymentLines();
		  myPayment = new FeeClaimPayments();
		  searchLine = new FeeClaimPayments();
	  }

}
