/*
 * $Id: ClaimCount.java,v 1.2 2009/08/31 22:17:47 vhahacnguyes Exp $
 */
package gov.va.med.fee.sec;


/**
 * POJO for storing counts of claims in different statuses.
 */
public class ClaimCount {

    /** The claims assigned. */
    private int claimsAssigned;

    /** The claims awaiting. */
    private int claimsAwaiting;

    /** The claims in process. */
    private int claimsInProcess;

    /** The claims error. */
    private int claimsError;

    /** The claims rejected. */
    private int claimsRejected;

    /**
     * Gets the claims rejected.
     *
     * @return the claims rejected
     */
    public final int getClaimsRejected() {
        return claimsRejected;
    }

    /**
    * Sets the claims rejected.
    *
    * @param claimsRejected the new claims rejected
    */
    public final void setClaimsRejected(final int claimsRejected) {
        this.claimsRejected = claimsRejected;
    }

    /**
    * Gets the claims in process.
    *
    * @return the claims in process
    */
    public final int getClaimsInProcess() {
        return claimsInProcess;
    }

    /**
     * Sets the claims in process.
     *
     * @param claimsInProcess the new claims in process
     */
    public final void setClaimsInProcess(final int claimsInProcess) {
        this.claimsInProcess = claimsInProcess;
    }

    /**
     * Gets the claims error.
     *
     * @return the claims error
     */
    public final int getClaimsError() {
        return claimsError;
    }

    /**
     * Sets the claims error.
     *
     * @param claimsError the new claims error
     */
    public final void setClaimsError(final int claimsError) {
        this.claimsError = claimsError;
    }

    /**
     * Gets the claims awaiting.
     *
     * @return the claims awaiting
     */
    public final int getClaimsAwaiting() {
        return claimsAwaiting;
    }

    /**
     * Sets the claims awaiting.
     *
     * @param claimsAwaiting the new claims awaiting
     */
    public final void setClaimsAwaiting(final int claimsAwaiting) {
        this.claimsAwaiting = claimsAwaiting;
    }

    /**
     * Gets the claims assigned.
     *
     * @return the claims assigned
     */
    public final int getClaimsAssigned() {
        return claimsAssigned;
    }

    /**
     * Sets the claims assigned.
     *
     * @param claimsAssigned the new claims assigned
     */
    public final void setClaimsAssigned(final int claimsAssigned) {
        this.claimsAssigned = claimsAssigned;
    }

    /**
     * Sets the count.
     *
     * @param status the status
     * @param count the count
     */
    public final void setCount(String status, final int count) {
        if ("ESTABLISH".equalsIgnoreCase(status)) {
            claimsAwaiting = count;
        } else if ("INPROCESS".equalsIgnoreCase(status)) {
            claimsInProcess = count;
        } else if ("PAYERROR".equalsIgnoreCase(status)) {
            claimsError = count;
        } else if ("REJECTED".equalsIgnoreCase(status)) {
            claimsRejected = count;
        }
    }
}
