/*
 * $Id: IDCheckServlet.java,v 1.6 2009/12/03 17:08:12 vhahacmagdua Exp $
 */
package gov.va.med.fee.sec;

import java.io.IOException;
import java.net.URLDecoder;
import java.text.MessageFormat;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * The Class IDCheckServlet.
 *
 */

@SuppressWarnings("serial")
public class IDCheckServlet extends HttpServlet {

    /**
    * {@inheritDoc}
    */
    @Override
    public final void init() throws ServletException {
    	 java.util.Date date = new java.util.Date();
         
        
    	 System.out.println("\nIDCheckServlet init() - STARTUP - the time is now: " + date + "\n");
    }

    /**
    * {@inheritDoc}
    */
    @Override
    protected final void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        doPost(req, resp);
    }

    /**
    * Checks if is valid.
    *
    * @param value
    *            the value
    *
    * @return true, if is valid
    */
    private boolean isValid(String value) {
        return value != null && value.trim().length() > 0 ? true : false;
    }

    /**
    * {@inheritDoc}
    */
    @Override
    protected final void doPost(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
    	
    	String userId = "";
    	String capturedUrl = "";
    	
    	HttpSession session = req.getSession();
    	String sessionId = req.getParameter("s");
    	
        /* START IDM: ATO Requirement to prevent URL hijack*/
    	
    	String paramI = URLDecoder.decode(req.getParameter("i"),"UTF-8");
System.out.println("doPost() - decoded paramI is: " + paramI);

		String paramC = URLDecoder.decode(req.getParameter("c"),"UTF-8");
System.out.println("doPost() - decoded paramC is: " + paramC);		
		
		try {
			userId = IDCheckAESEncryption.decrypt(paramI);
System.out.println("doPost() - IDCheckAESEncryption.decrypt() decrypted userId is: " + userId);

			capturedUrl = IDCheckAESEncryption.decrypt(paramC);
System.out.println("doPost() - IDCheckAESEncryption.decrypt decrypted capturedUrl is: " + capturedUrl);

		} catch (Exception e) {
			e.printStackTrace();
		}
		
//        String host = req.getLocalName();
//        int port = req.getLocalPort();
//        host = new StringBuffer(host).append(':').append(port).toString();              
//        String capturedUrl = MessageFormat.format(IDCheckFilter.getDefaultPage(), host);
    	
    	System.out.println(new StringBuffer("doPost() Security Filter Parameters [")
        .append("paramI:" + paramI)
        .append(",paramC:" + paramC)
        .append(",userId:" + userId)
        .append(",capturedUrl:" + capturedUrl)
        .append(",sessionId:" + sessionId)
        .append("]").toString());
        
       /*END IDM*/

        boolean status = true;
        status &= isValid(userId);
        status &= isValid(capturedUrl);

        if (!status) {
            try {
                session.invalidate();
            } catch (IllegalStateException e) { // NOPMD
                // Ignore! For IE, when user clicks back button twice after
                // login
                // this is called twice.
            }
            System.out.println(String.format("Problem authorizing [Rec - Id: {0} capturedURL: {1} ]", userId, capturedUrl));
            String errorPage = (String) req.getAttribute(IDCheckFilter.ERROR_PAGE);
            resp.sendRedirect(errorPage);
            return;
        }

        session.setAttribute(IDCheckFilter.GUID, userId);
        
        
        
        resp.sendRedirect(capturedUrl);
    }
}
