package gov.va.med.fee.tool;

import gov.va.med.domain.fee.VaFacility;
import gov.va.med.domain.fee.VaFacilityType;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.framework.EntityHome;

/**
 * The Class VaFacilityTypeHome.
 */
@Name("vaFacilityTypeHome")
public class VaFacilityTypeHome extends EntityHome<VaFacilityType> {

    /**
     * Sets the type.
     *
     * @param id the new type
     */
    public void setVaFacilityTypeVaTypeCd(String id) {
        setId(id);
    }

    /**
     * Gets the type.
     *
     * @return the type
     */
    public String getVaFacilityTypeVaTypeCd() {
        return (String) getId();
    }

    /**
     * Wire.
     */
    public void wire() {
        getInstance();
    }

    /**
     * Checks if is wired.
     *
     * @return true, if is wired
     */
    public boolean isWired() {
        return true;
    }

    /**
     * Gets the defined instance.
     *
     * @return the defined instance
     */
    public VaFacilityType getDefinedInstance() {
        return isIdDefined() ? getInstance() : null;
    }


    /**
     * Gets the facilities.
     *
     * @return the facilities
     */
    public List<VaFacility> getVaFacilities() {
        return getInstance() == null ? null : new ArrayList<VaFacility>(
                getInstance().getVaFacilities());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected VaFacilityType createInstance() {
        VaFacilityType vaFacilityType = new VaFacilityType();
        return vaFacilityType;
    }

    /**
     * Overrides to return the correct persistent context name for this app.
     *
     * @return persistence context name
     */
    @Override
    protected final String getPersistenceContextName() {
       return "FPPSEntityManager";
    }
}
