package gov.va.med.fee.tool;

import gov.va.med.domain.fee.VaFacility;
import gov.va.med.domain.fee.Visn;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.security.Restrict;
import org.jboss.seam.framework.EntityHome;

/**
 * The Class VisnHome.
 */
@Name("visnHome")
@Restrict("#{s:hasRole('FEE_SUPERVISOR') || s:hasRole('FEE_VISN_PGM_MANAGER') || s:hasRole('ADMIN')}")
public class VisnHome extends EntityHome<Visn> {

    /**
     * Sets the code.
     *
     * @param id the new code
     */
    public void setVisnVisnIdCd(Long id) {
        setId(id);
    }

    /**
     * Gets the code.
     *
     * @return the code
     */
    public Long getVisnVisnIdCd() {
        return (Long) getId();
    }

    /**
     * Wire.
     */
    public void wire() {
        getInstance();
    }

    /**
     * Checks if is wired.
     *
     * @return true, if is wired
     */
    public boolean isWired() {
        return true;
    }

    /**
     * Gets the defined instance.
     *
     * @return the defined instance
     */
    public Visn getDefinedInstance() {
        return isIdDefined() ? getInstance() : null;
    }

    /**
     * Gets the facilities.
     *
     * @return the facilities
     */
    public List<VaFacility> getVaFacilities() {
        return getInstance() == null ? null : new ArrayList<VaFacility>(
                getInstance().getVaFacilities());
    }

    /**
     * Overrides to return the correct persistent context name for this app.
     *
     * @return persistence context name
     */
    @Override
    protected final String getPersistenceContextName() {
       return "FPPSEntityManager";
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Visn createInstance() {
        Visn visn = new Visn();
        return visn;
    }

}
