

import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.Cipher;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.File;
import javax.crypto.spec.SecretKeySpec;
import javax.crypto.spec.DESKeySpec;
import java.util.StringTokenizer;

public class PasswordUtil {
  private static byte[] IV =
      { 0x12, 0x79, 0x6c, 0x43, 0x47, 0x2b, 0x3c, 0x6d};

  private static String algoParams = "DES/CBC/PKCS5Padding";


  public static void main(String[] args) throws Exception {

    String action = args[0];

	try{
		if(action.equals("generateKey") ){
			generateKey();
			System.exit(0);
		}

		else if(action.equals("generatePassword") ){
			generatePassword(args[1] );
			System.exit(0);
		}

		else if(action.equals("decrypt") ){
			 byte[] pwdBytes = parseBytes(args[1]);

			 //byte[] decrypted = decrypt(args[1].getBytes());
			 System.out.println("pwdBytes: " + pwdBytes);
			byte[] decrypted = decrypt(pwdBytes);

			 System.out.println("decrypted: " + new String(decrypted) );
			 System.exit(0);
		}
		else{
			System.out.println("Usage is [generateKey/generatePassword/decrypt] [password]");
			System.exit(1);
		}
	}catch(Exception e){

		System.out.println("Error occurred in encryption: " + e.getMessage());
		e.printStackTrace();
	}
  }

  public static byte[] parseBytes(String inBytes) throws Exception{

	  	StringTokenizer tok = new StringTokenizer(inBytes, " ");
	  	byte[] pwdBytes = new byte[tok.countTokens()];

	  	int i = 0;
	  	while(tok.hasMoreTokens()){
			String str = tok.nextToken();
			int j = Integer.parseInt(str);
			Byte byt = new Byte((byte) j);
			pwdBytes[i] = byt.byteValue();
			i++;
		}

		return pwdBytes;
  }


  public static byte[] encrypt(byte[] encryptBytes) throws Exception {

  	  SecretKey key = getKey();
      Cipher cipher = Cipher.getInstance(algoParams);
      IvParameterSpec ivParam = new IvParameterSpec(IV);
      cipher.init(Cipher.ENCRYPT_MODE, key,ivParam);

      return cipher.doFinal(encryptBytes);
  }

  public static byte[] decrypt(byte[] decryptBytes) throws Exception {

	  SecretKey key = getKey();
	  return decrypt(decryptBytes,key);
  }

  private static SecretKey getKey() throws Exception {

	  File file = new File("./key.txt");
	  FileInputStream inStream = new FileInputStream(file);
	  byte[] keyBytes = new byte[inStream.available()];
	  inStream.read(keyBytes);

      DESKeySpec keySpec = new DESKeySpec(keyBytes);
      SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
	  SecretKey key = keyFactory.generateSecret(keySpec);
	  return key;

  }

  private static byte[] decrypt(byte[] decryptBytes,
      SecretKey key) throws Exception {

    Cipher cipher = Cipher.getInstance(algoParams);
    IvParameterSpec ivParam = new IvParameterSpec(IV);

    cipher.init(Cipher.DECRYPT_MODE, key, ivParam);
    return cipher.doFinal(decryptBytes);
  }

  public static void generateKey() throws Exception{

    File keyFile = new File("./key.txt");
    FileOutputStream out = new FileOutputStream(keyFile);

    KeyGenerator kg = KeyGenerator.getInstance("DES");
    kg.init(56);

    SecretKey key = kg.generateKey();
    byte[] byteKey = key.getEncoded();
    out.write(byteKey);

  }


  public static String generatePassword(String password) throws Exception{

	File pwdFile = new File("./pwd.txt");
	FileOutputStream out = new FileOutputStream(pwdFile);
    byte[] encBytes = encrypt(password.getBytes() );

    String buf = new String("");
	Byte bigByte = new Byte( encBytes[0] );
	buf += bigByte.intValue();
	for(int i = 1; i < encBytes.length; i++){
		bigByte = new Byte( encBytes[i] );
		buf += " " + bigByte.intValue();
	}

    String encString = new String(encBytes);
    out.write(encBytes);
    System.out.println("The generated password is: " + buf + " also found in ./pwd.txt");
    return new String(encBytes);
  }

}