/* $Id: ClaimPayment.java,v 1.10 2009/10/24 01:29:27 vhahacmagdua Exp $ */
package gov.va.med.domain.fppsowner;


// Generated Sep 25, 2009 8:34:06 AM by Hibernate Tools 3.2.5.Beta
import java.math.BigDecimal;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


/**
 * ClaimPayment generated by hbm2java
 */
@SuppressWarnings("serial")
@Entity(name = "foClaimPayment")
@Table(name = "CLAIM_PAYMENT")
public class ClaimPayment implements java.io.Serializable {
    private long claimPaymentId;
    private Claim claim;
    private ClaimPaymentType claimPaymentType;
    private Date paymentBatchDate;
    private Date treasuryPaymentDate;
    private BigDecimal paidAmount;
    private String paymentTrackingNumber;
    private Date feeInvoiceDate;
    private String feeInvoiceNumber;
    private String createdBy;
    private Date dateCreated;
    private Set<ClaimProcRecon> claimProcRecons = new HashSet<ClaimProcRecon>(0);

    public ClaimPayment() {
    }

    public ClaimPayment(long claimPaymentId, Claim claim,
        ClaimPaymentType claimPaymentType, Date paymentBatchDate,
        String createdBy, Date dateCreated) {
        this.claimPaymentId = claimPaymentId;
        this.claim = claim;
        this.claimPaymentType = claimPaymentType;
        this.paymentBatchDate = paymentBatchDate;
        this.createdBy = createdBy;
        this.dateCreated = dateCreated;
    }

    public ClaimPayment(long claimPaymentId, Claim claim,
        ClaimPaymentType claimPaymentType, Date paymentBatchDate,
        Date treasuryPaymentDate, BigDecimal paidAmount,
        String paymentTrackingNumber, Date feeInvoiceDate,
        String feeInvoiceNumber, String createdBy, Date dateCreated,
        Set<ClaimProcRecon> claimProcRecons) {
        this.claimPaymentId = claimPaymentId;
        this.claim = claim;
        this.claimPaymentType = claimPaymentType;
        this.paymentBatchDate = paymentBatchDate;
        this.treasuryPaymentDate = treasuryPaymentDate;
        this.paidAmount = paidAmount;
        this.paymentTrackingNumber = paymentTrackingNumber;
        this.feeInvoiceDate = feeInvoiceDate;
        this.feeInvoiceNumber = feeInvoiceNumber;
        this.createdBy = createdBy;
        this.dateCreated = dateCreated;
        this.claimProcRecons = claimProcRecons;
    }

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "fo_seq")
    @SequenceGenerator(name = "fo_seq", sequenceName = "FPPS_OWNER.MIG")
    @Column(name = "CLAIM_PAYMENT_ID", unique = true, nullable = false, precision = 15, scale = 0)
    public long getClaimPaymentId() {
        return this.claimPaymentId;
    }

    public void setClaimPaymentId(long claimPaymentId) {
        this.claimPaymentId = claimPaymentId;
    }

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CLAIM_INDEX", nullable = false)
    public Claim getClaim() {
        return this.claim;
    }

    public void setClaim(Claim claim) {
        this.claim = claim;
    }

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CLAIM_PAYMENT_TYPE_CODE", nullable = false)
    public ClaimPaymentType getClaimPaymentType() {
        return this.claimPaymentType;
    }

    public void setClaimPaymentType(ClaimPaymentType claimPaymentType) {
        this.claimPaymentType = claimPaymentType;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "PAYMENT_BATCH_DATE", nullable = false, length = 7)
    public Date getPaymentBatchDate() {
        return this.paymentBatchDate;
    }

    public void setPaymentBatchDate(Date paymentBatchDate) {
        this.paymentBatchDate = paymentBatchDate;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "TREASURY_PAYMENT_DATE", length = 7)
    public Date getTreasuryPaymentDate() {
        return this.treasuryPaymentDate;
    }

    public void setTreasuryPaymentDate(Date treasuryPaymentDate) {
        this.treasuryPaymentDate = treasuryPaymentDate;
    }

    @Column(name = "PAID_AMOUNT", precision = 10)
    public BigDecimal getPaidAmount() {
        return this.paidAmount;
    }

    public void setPaidAmount(BigDecimal paidAmount) {
        this.paidAmount = paidAmount;
    }

    @Column(name = "PAYMENT_TRACKING_NUMBER", length = 16)
    public String getPaymentTrackingNumber() {
        return this.paymentTrackingNumber;
    }

    public void setPaymentTrackingNumber(String paymentTrackingNumber) {
        this.paymentTrackingNumber = paymentTrackingNumber;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "FEE_INVOICE_DATE", length = 7)
    public Date getFeeInvoiceDate() {
        return this.feeInvoiceDate;
    }

    public void setFeeInvoiceDate(Date feeInvoiceDate) {
        this.feeInvoiceDate = feeInvoiceDate;
    }

    @Column(name = "FEE_INVOICE_NUMBER", length = 9)
    public String getFeeInvoiceNumber() {
        return this.feeInvoiceNumber;
    }

    public void setFeeInvoiceNumber(String feeInvoiceNumber) {
        this.feeInvoiceNumber = feeInvoiceNumber;
    }

    @Column(name = "CREATED_BY", nullable = false, length = 30)
    public String getCreatedBy() {
        return this.createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "DATE_CREATED", nullable = false, length = 7)
    public Date getDateCreated() {
        return this.dateCreated;
    }

    public void setDateCreated(Date dateCreated) {
        this.dateCreated = dateCreated;
    }

    @OneToMany(fetch = FetchType.LAZY, mappedBy = "claimPayment",  cascade = CascadeType.ALL)
    public Set<ClaimProcRecon> getClaimProcRecons() {
        return this.claimProcRecons;
    }

    public void setClaimProcRecons(Set<ClaimProcRecon> claimProcRecons) {
        this.claimProcRecons = claimProcRecons;
    }
}
