package gov.va.med.hac.edi.reposload.claimstatus.b1.jpa;

import gov.va.med.hac.edi.utils.*;
import gov.va.med.hac.edi.utils.jpa.DbTransactionEnderException;

import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import java.util.logging.*;
import javax.naming.NamingException;

public class NCPDPClaimStatusB1
{
  public NCPDPClaimStatusB1(String fPath, String fName, PrintWriter vLogFile)
  throws IOException, NamingException, DbTransactionEnderException
  {
    ProcessClaimStatusB1 pCsB1 = new ProcessClaimStatusB1(vLogFile);
    
    pCsB1.processClmStLoad(fPath, fName);
  }

  /**
   *
   * @param args
   */
  public static void main(String[] args)
  {
    // Local variables
    PrintWriter vLogFile;
    String fileName = null;
    boolean processSuccess = false;
        
    // Set up a log file
    // If there is any problem with the log file, go no further
    try {
      vLogFile = MainUtils.establishLogFile("Log", "NCPDPClaimStatusB1Log.txt");
    
    // If there was a problem setting up the log file, we cannot log to it
    //   Log through the Java Logging API, which we could configure to do
    //   something useful in the future
    } catch(Exception ex) {
      Logger.getLogger(NCPDPClaimStatusB1.class.getName()).log(Level.SEVERE, null, ex);
      return;
    }
      
    // Catch any exception (outside of setting up for logging)
    try {
      MainUtils.stampStartingTime("Cache X12 Extract Start", vLogFile);
      vLogFile.println("Code Version: Refactoring Project");
      vLogFile.flush();

      String fPath = "";
      String fName = "";
      if (args.length != 0) {
        fPath = args[0];
      }
      if (args.length > 1) {
        fName = args[1];
      }

      if (fPath != null && fPath.length() > 0
                        && fName != null && fName.length() > 0) {
          vLogFile.println ("File Path: " + fPath);
          vLogFile.println ("File Name: " + fName);
          vLogFile.flush();
          new NCPDPClaimStatusB1(fPath, fName, vLogFile);
      } else {
          vLogFile.println("NCPDPClaimStatusB1: Please Pass both Parameters");
      }

      // Put a completion message into the log file
      vLogFile.println ("Process completed successfully");
      vLogFile.flush();
      processSuccess = true;

    } catch (OutOfMemoryError e) {
        Logger.getLogger(NCPDPClaimStatusB1.class.getName()).log(Level.SEVERE,
              "!!!!! Out Of Memory Error !!!!!", e);
        vLogFile.println("!!!!! Out Of Memory Error !!!!!");
    } catch (Exception e) {
        Logger.getLogger(NCPDPClaimStatusB1.class.getName()).log(Level.SEVERE,
            "Exception in processing", e);
        e.printStackTrace(vLogFile);
    } finally {
      if (!processSuccess) {
        vLogFile.println("!!!!! Process seems to have failed !!!!!");
      }
      if (vLogFile != null) {
        MainUtils.stampEndingTime("NCPDP Claim Status B1 End", vLogFile);
        vLogFile.flush();
      }
    }
  }
//    SimpleDateFormat transDate = new SimpleDateFormat("MM/dd/yyyy") ;
//    SimpleDateFormat transTime = new SimpleDateFormat("HH:mm:ss:SSS") ;
//    String vTransDate, vTransTime = "" ;
//    Calendar calendar = new GregorianCalendar() ;
//    java.util.Date date = calendar.getTime() ;
//    vTransDate = transDate.format( date ) ;
//    vTransTime = transTime.format( date ) ;
//    File logFile = new File("Log/NCPDPClaimStatusRB1Log.txt") ;
//    PrintWriter vLogFile = null;
//    String fPath = "" ;
//    String fName = "" ;
//
//    try
//    {
//      vLogFile = new PrintWriter(new FileOutputStream(logFile, true)) ;
//      vLogFile.println("========================================================") ;
//      vLogFile.println("NCPDP Loading Start " + vTransDate + " " + vTransTime);
//      vLogFile.println("  ");
//      vLogFile.flush();
//
//      if (args.length != 0)
//      {
//        fPath = args[0];
//      }
//      if (args.length > 1)
//      {
//        fName = args[1];
//      }
//
//      NCPDPClaimStatusB1 ncpCsB1 = new NCPDPClaimStatusB1(fPath, fName, vLogFile);
//
//      calendar = new GregorianCalendar();
//      date = calendar.getTime();
//      vTransDate = transDate.format( date ) ;
//      vTransTime = transTime.format( date ) ;
//      vLogFile.println("  ") ;
//      vLogFile.println("NCPDP Loading End   " + vTransDate + " " + vTransTime);
//      vLogFile.println("========================================================");
//      vLogFile.println("  ");
//      vLogFile.flush();
//    }
//    catch (Exception e)
//    {
//      e.printStackTrace();
//      e.printStackTrace(vLogFile);
//    }
//  }
}