package gov.va.med.hac.edi.reposload.claimstatus.b2.jpa;

import gov.va.med.hac.edi.utils.*;
import gov.va.med.hac.edi.utils.jpa.DbTransactionEnderException;

import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import java.util.logging.*;
import javax.naming.NamingException;

public class NCPDPRevStatusB2
{
  public NCPDPRevStatusB2(String fPath, String fName, PrintWriter vLogFile)
  throws IOException, NamingException, DbTransactionEnderException
  {
    ProcessRevStatusB2 pRevStB2 = new ProcessRevStatusB2(vLogFile);
    
    pRevStB2.processRevStLoad(fPath, fName);
  }

  /**
   *
   * @param args
   */
  public static void main(String[] args)
  {
    // Local variables
    PrintWriter vLogFile;
    String fileName = null;
    boolean processSuccess = false;
        
    // Set up a log file
    // If there is any problem with the log file, go no further
    try {
      vLogFile = MainUtils.establishLogFile("Log", "NCPDPRevStatusB2Log.txt");
    
    // If there was a problem setting up the log file, we cannot log to it
    //   Log through the Java Logging API, which we could configure to do
    //   something useful in the future
    } catch(Exception ex) {
      Logger.getLogger(NCPDPRevStatusB2.class.getName()).log(Level.SEVERE, null, ex);
      return;
    }
      
    // Catch any exception (outside of setting up for logging)
    try {
      MainUtils.stampStartingTime("NCPDP Rev Status B2 Start", vLogFile);
      vLogFile.println("Code Version: Refactoring Project");
      vLogFile.flush();

      String fPath = "" ;
      String fName = "" ;
      if (args.length != 0)
      {
        fPath = args[0];
      }
      if (args.length > 1)
      {
        fName = args[1];
      }

      if (fPath != null && fPath.length() > 0
                        && fName != null && fName.length() > 0) {
          vLogFile.println ("File Path: " + fPath);
          vLogFile.println ("File Name: " + fName);
          vLogFile.flush();
          new NCPDPRevStatusB2(fPath, fName, vLogFile);
      } else {
          vLogFile.println("NCPDPRevStatusB2: Please Pass both Parameters");
      }

      // Put a completion message into the log file
      vLogFile.println ("Process completed successfully");
      vLogFile.flush();
      processSuccess = true;
      
    } catch (OutOfMemoryError e) {
        Logger.getLogger(NCPDPRevStatusB2.class.getName()).log(Level.SEVERE,
              "!!!!! Out Of Memory Error !!!!!", e);
        vLogFile.println("!!!!! Out Of Memory Error !!!!!");
    } catch (Exception e) {
        Logger.getLogger(NCPDPRevStatusB2.class.getName()).log(Level.SEVERE,
            "Exception in processing", e);
        e.printStackTrace(vLogFile);
    } finally {
      if (!processSuccess) {
        vLogFile.println("!!!!! Process seems to have failed !!!!!");
      }
      if (vLogFile != null) {
        MainUtils.stampEndingTime("NCPDP Rev Status B2 End", vLogFile);
        vLogFile.flush();
      }
    }
  }
}