package gov.va.med.hac.edi.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

/**
 * A utility class to rename the outgoing EMDEON 997 files
 * into the proper format.
 */
public class Rename999 {

   private Rename999() { }

   /**
    * Driver for the Rename997 process.  Input is a list of files
    * to be renamed normally found in the ecedigs\PF_PostOffice\EMDEON\OUT
    * folder.
    *
    * @param args the list of files to be renamed.
    *
    * @throws Exception on any error in renaming the files.
    */
   public static void main(String[] args) throws Exception {
      final int rcvIdBegIdx = 35;
      final int rcvIdEndIdx = 40;
      String line = "";
      for (String filename : args) {
         String oldfilename = filename.trim();
         File file = new File(oldfilename);
         BufferedReader in = new BufferedReader(new FileReader(oldfilename));
         if ((line = in.readLine()) != null) {
            String payerId = line.substring(rcvIdBegIdx, rcvIdEndIdx);
            String newfilename = oldfilename.replaceFirst("999_EMDEON", "999_" + payerId);
            in.close();
            file.renameTo(new File(newfilename));
         }
      }
   }
}
