package gov.va.med.hac.edi.utils.jpa;

import org.slf4j.Logger;
import gov.va.med.domain.erepos.batchload.*;
import gov.va.med.hac.edi.utils.logutils.jpa.*;

public class NCPDPLogUtils {

  public static void logNCPDPLoadFieldNames(String heading, Logger logger) {
    logger.trace("NCPDP_BATCH field names: " + NcpdpBatchDAO.getFieldNames());
    logger.trace("NCPDP_HEADER field names: " + NcpdpHeaderDAO.getFieldNames());
    logger.trace("NCPDP_CLAIM field names: " + NcpdpClaimDAO.getFieldNames());
    logger.trace("NCPDP_PATIENT field names: " + NcpdpPatientDAO.getFieldNames());
    logger.trace("NCPDP_INSURANCE field names: " + NcpdpInsuranceDAO.getFieldNames());
    logger.trace("NCPDP_CLAIM_PROC_MOD field names: " + NcpdpClaimProcModDAO.getFieldNames());
    logger.trace("NCPDP_PROVIDER field names: " + NcpdpProviderDAO.getFieldNames());
    logger.trace("NCPDP_PRESCRIBER field names: " + NcpdpPrescriberDAO.getFieldNames());
    logger.trace("NCPDP_COB field names: " + NcpdpCobDAO.getFieldNames());
    logger.trace("NCPDP_COB_OT_PAYER field names: " + NcpdpCobOtPayerDAO.getFieldNames());
    logger.trace("NCPDP_COB_OT_PAYER_AMOUNT field names: "
        + NcpdpCobOtPayerAmountDAO.getFieldNames());
    logger.trace("NCPDP_COB_OT_PAYER_REJECT field names: "
        + NcpdpCobOtPayerRejectDAO.getFieldNames());
    logger.trace("NCPDP_WORK_COMP field names: " + NcpdpWorkCompDAO.getFieldNames());
    logger.trace("NCPDP_DUR_PPS field names: " + NcpdpDurPpsDAO.getFieldNames());
    logger.trace("NCPDP_PRICING field names: " + NcpdpPricingDAO.getFieldNames());
    logger.trace("NCPDP_PRICING_OT_AMOUNT field names: " + NcpdpPricingOtAmountDAO.getFieldNames());
    logger.trace("NCPDP_COUPON field names: " + NcpdpCouponDAO.getFieldNames());
    logger.trace("NCPDP_COMPOUND field names: " + NcpdpCompoundDAO.getFieldNames());
    logger.trace("NCPDP_COMPOUND_INGR field names: " + NcpdpCompoundIngrDAO.getFieldNames());
    logger.trace("NCPDP_PRIOR_AUTH field names: " + NcpdpPriorAuthDAO.getFieldNames());
    logger.trace("NCPDP_CLINICAL field names: " + NcpdpClinicalDAO.getFieldNames());
    logger.trace("NCPDP_CLINICAL_DIAG field names: " + NcpdpClinicalDiagDAO.getFieldNames());
    logger.trace("NCPDP_CLINICAL_MEAS field names: " + NcpdpClinicalMeasDAO.getFieldNames());
  }

  public static void logNCPDPExtractFieldNames(String heading, Logger logger) {
    logger.trace("NCPDP_BATCH field names: " + NcpdpBatchLogger.getFieldNames());
    logger.trace("NCPDP_HEADER field names: " + NcpdpHeaderLogger.getFieldNames());
    logger.trace("NCPDP_CLAIM field names: " + NcpdpClaimLogger.getFieldNames());
    logger.trace("NCPDP_PATIENT field names: " + NcpdpPatientLogger.getFieldNames());
    logger.trace("NCPDP_INSURANCE field names: " + NcpdpInsuranceLogger.getFieldNames());
    logger.trace("NCPDP_PRESCRIBER field names: " + NcpdpPrescriberLogger.getFieldNames());
    logger.trace("NCPDP_COB field names: " + NcpdpCobLogger.getFieldNames());
    logger.trace("NCPDP_COB_OT_PAYER field names: " + NcpdpCobOtPayerLogger.getFieldNames());
    logger.trace("NCPDP_COB_OT_PAYER_AMOUNT field names: "
        + NcpdpCobOtPayerAmountLogger.getFieldNames());
    logger.trace("NCPDP_COB_OT_PAYER_REJECT field names: "
        + NcpdpCobOtPayerRejectLogger.getFieldNames());
    logger.trace("NCPDP_PRICING field names: " + NcpdpPricingLogger.getFieldNames());
  }
}
